Package: fMultivar
Title: Rmetrics - Modeling of Multivariate Financial Return
        Distributions
Date: 2023-07-07
Version: 4031.84
Authors@R: c( person("Diethelm", "Wuertz", role = "aut"),
              person("Tobias", "Setz", role = "aut"),
              person("Stefan", "Theussl", role = c("aut", "cre"), email = "Stefan.Theussl@R-Project.org"),
	      person("Yohan", "Chalabi", role = "ctb"),
	      person("Martin", "Maechler", role = "ctb"),
	      person("CRAN", "team", role = "ctb") )
Description: A collection of functions inspired by Venables and Ripley (2002) <doi:10.1007/978-0-387-21706-2>
             and Azzalini and Capitanio (1999) <arXiv:0911.2093> to manage, investigate and analyze
             bivariate and multivariate data sets of financial returns.
Imports: fBasics, cubature, mvtnorm, sn, methods, grDevices, graphics,
        stats
Suggests: RUnit, tcltk
License: GPL (>= 2)
URL: https://www.rmetrics.org
NeedsCompilation: no
Packaged: 2023-07-07 17:26:47 UTC; theussl
Author: Diethelm Wuertz [aut],
  Tobias Setz [aut],
  Stefan Theussl [aut, cre],
  Yohan Chalabi [ctb],
  Martin Maechler [ctb],
  CRAN team [ctb]
Maintainer: Stefan Theussl <Stefan.Theussl@R-Project.org>
Repository: CRAN
Date/Publication: 2023-07-11 08:40:35 UTC
Built: R 4.6.0; ; 2026-04-27 23:38:26 UTC; unix

Package: fMultivar
Title: Rmetrics - Modeling of Multivariate Financial Return
        Distributions
Date: 2023-07-07
Version: 4031.84
Authors@R: c( person("Diethelm", "Wuertz", role = "aut"),
              person("Tobias", "Setz", role = "aut"),
              person("Stefan", "Theussl", role = c("aut", "cre"), email = "Stefan.Theussl@R-Project.org"),
	      person("Yohan", "Chalabi", role = "ctb"),
	      person("Martin", "Maechler", role = "ctb"),
	      person("CRAN", "team", role = "ctb") )
Description: A collection of functions inspired by Venables and Ripley (2002) <doi:10.1007/978-0-387-21706-2>
             and Azzalini and Capitanio (1999) <arXiv:0911.2093> to manage, investigate and analyze
             bivariate and multivariate data sets of financial returns.
Imports: fBasics, cubature, mvtnorm, sn, methods, grDevices, graphics,
        stats
Suggests: RUnit, tcltk
License: GPL (>= 2)
URL: https://www.rmetrics.org
NeedsCompilation: no
Packaged: 2023-07-07 17:26:47 UTC; theussl
Author: Diethelm Wuertz [aut],
  Tobias Setz [aut],
  Stefan Theussl [aut, cre],
  Yohan Chalabi [ctb],
  Martin Maechler [ctb],
  CRAN team [ctb]
Maintainer: Stefan Theussl <Stefan.Theussl@R-Project.org>
Repository: CRAN
Date/Publication: 2023-07-11 08:40:35 UTC

################################################################################
## Exports
################################################################################
exportPattern("^[^\\.]") # <<< This is bad -- FIXME !!

S3method("contour", "gridData")
S3method("persp",   "gridData")
S3method("plot", "hexBinning")
S3method("plot", "squareBinning")

################################################################################
## Imports
################################################################################
importFrom("mvtnorm", pmvt)
importFrom("fBasics",
           .contourPlot, .perspPlot, # <-> inst/unitTests/runit.BivariateDistributions.R
           .sliderMenu)
importFrom("sn",
           ## R/zzz-mvstnorm.R :
           dmsn, pmsn, rmsn,
           dmst, pmst, rmst,
           ## R.mvdist-msnFit.R :
           mst.mple, msn.mle)

importFrom("grDevices", heat.colors)
importFrom("graphics", box, contour, image, par, persp, points, polygon, rug, title)
importFrom("methods", new)
importFrom("stats", cov, dnorm, mahalanobis, pnorm, quantile, rchisq, rnorm, var)

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  grid2d                Returns from two vectors x-y grid coordinates
#  density2d             Returns 2D Kernel Density Estimates
#  hist2d                Returns 2D Histogram Counts
# FUNCTION:             BIVARIATE DISTRIBUTIONS:
#  pnorm2d               Computes bivariate Normal probability function
#  dnorm2d               Computes bivariate Normal density function
#  rnorm2d               Generates bivariate normal random deviates
#  pcauchy2d             Computes bivariate Cauchy probability function
#  dcauchy2d             Computes bivariate Cauchy density function
#  rcauchy2d             Generates bivariate Cauchy random deviates
#  pt2d                  Computes bivariate Student-t probability function
#  dt2d                  Computes bivariate Student-t density function
#  rt2d                  Generates bivariate Student-t random deviates
# FUNCTION:             ELLIPTICAL DISTRIBUTIONS:
#  delliptical2d         Computes density for elliptical distributions
# REQUIREMENTS:
.perspPlot   <- fBasics::.perspPlot
.contourPlot <- fBasics::.contourPlot
################################################################################


test.grid2d =
function()
{
    # Grid Data:
    grid2d(x = (0:10)/10)
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.density2d =
    function()
{
    # Data:
    z <- rnorm2d(1000)
    
    # Density:
    D = density2d(x = z[, 1], y = z[, 2])
    .perspPlot(D)
    .contourPlot(D)
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.hist2d =
    function()
{
    # Data:
    z <- rnorm2d(1000)
   
    # Histogram:
    H <- hist2d(x = z[, 1], y = z[, 2])
    .perspPlot(H)
    .contourPlot(H)

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.norm2d =
    function()
{
    #  pnorm2d - Computes bivariate Normal probability function
    #  dnorm2d - Computes bivariate Normal density function
    #  rnorm2d - Generates bivariate normal random deviates
    
    # Normal Density:
    x = (-40:40)/10
    X = grid2d(x)
    z = dnorm2d(X$x, X$y)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
    
    # Normal Density, rho = 0.5:
    x = (-40:40)/10
    X = grid2d(x)
    z = dnorm2d(X$x, X$y, rho = 0.5)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
 
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.cauchy2d =
    function()
{
    #  pcauchy2d - Computes bivariate Cauchy probability function
    #  dcauchy2d - Computes bivariate Cauchy density function
    #  rcauchy2d - Generates bivariate Cauchy random deviates
    
    # Cauchy Density:
    x = (-40:40)/10
    X = grid2d(x)
    z = dcauchy2d(X$x, X$y)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
    
    # Cauchy Density, rho = 0.5:
    x = (-40:40)/10
    X = grid2d(x)
    z = dcauchy2d(X$x, X$y, rho = 0.5)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
 
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.t2d =
    function()
{
    #  pt2d - Computes bivariate Student-t probability function
    #  dt2d - Computes bivariate Student-t density function
    #  rt2d - Generates bivariate Student-t random deviates
    
    # Student Density:
    x = (-40:40)/10
    X = grid2d(x)
    z = dt2d(X$x, X$y, nu = 4)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
    
    # Student Density, rho = 0.5:
    x = (-40:40)/10
    X = grid2d(x)
    z = dt2d(X$x, X$y, rho = 0.5, nu = 4)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
 
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.delliptical2d =
    function()
{ 
    # Settings:
    xy = grid2d((-50:50)/10)
    
    # Contour Plots:
    par(mfrow = c(1, 1))
    contour(delliptical2d(xy, rho = 0.75, param = NULL, 
        type = "norm", output = "list"), main = "norm")
    contour(delliptical2d(xy, rho = 0.75, param = NULL, 
        type = "cauchy", output = "list"), main = "cauchy")
    contour(delliptical2d(xy, rho = 0.75, param = 4, 
        type = "t", output = "list"), main = "t")
    contour(delliptical2d(xy, rho = 0.75, param = NULL, 
        type = "laplace", output = "list"), main = "laplace")
    contour(delliptical2d(xy, rho = 0.75, param = NULL, 
        type = "kotz", output = "list"), main = "kotz")
    contour(delliptical2d(xy, rho = 0.75, param = NULL, 
        type = "epower", output = "list"), main = "epower")
        
    # Return Value:
    return()    
}


################################################################################
    

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  adapt                 Integrates over a two dimensional unit square
################################################################################


# Title: adapt -- multidimensional numerical integration
# Package: adapt
# Version: 1.0-4
# Author: FORTRAN by Alan Genz, 
#     S by Mike Meyer, R by Thomas Lumley and Martin Maechler
# Description: Adaptive Quadrature in up to 20 dimensions
# Depends:
# License: Unclear (Fortran) -- code in Statlib's ./S/adapt
# Maintainer: Thomas Lumley <tlumley@u.washington.edu>
# Packaged: Fri Apr 20 11:38:07 2007; thomas


# [from Statlib's original  http://lib.stat.cmu.edu/S/adapt ]
# This code contains an S function and supporting C and Fortran code for
# adaptive quadrature.  The underlyling fortran code is purported to
# work in from 2 to 20 dimensions.  The code is set up to dynamically
# load from a central library area.  If you can not do dynamic loading,
# you may need to build a staticly loaded version.  The adapt S function
# calls load.if.needed to do the dynamic loading.  You will have to
# change the functions used here (probably to call library.dynam).
# S code written by Michael Meyer (mikem@andrew.cmu.edu).
# October, 1989.


# 2002-03-14  Martin Maechler  <maechler@stat.math.ethz.ch>
# * DESCRIPTION (Version): 1.0-3 --> CRAN
# * R/adapt.R (adapt): use defaults for minpts, maxpts, eps;
#   more logical maxpts default (for ndim >= 7) using rulcls
# * man/adapt.Rd: extended example
# 2002-03-13  Martin Maechler  <maechler@stat.math.ethz.ch>
# * DESCRIPTION (Version): 1.0-2
# * man/adapt.Rd: indentation, using \code{.}, etc;
#   example also tries p=5 dimensions
# * R/adapt.R: clean up (spaces)
# 2002-01-09  Martin Maechler  <maechler@stat.math.ethz.ch>
# * R/adapt.R: do not use .Alias anymore
# 2001-06-29  Thomas Lumley <tlumley@u.washington.edu>
# * move (improved!) integrate() into base, using .Call() etc.


# Message-ID: <4AD7A74B.3020108@math.wsu.edu>
# Date: Thu, 15 Oct 2009 15:50:51 -0700
# From: Alan Genz <genz@math.wsu.edu>
# User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.21) 
#     Gecko/20090402 SeaMonkey/1.1.16
# MIME-Version: 1.0
# To: Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
# CC: Alan C Genz <alangenz@wsu.edu>
# Subject: Re: adapt
# References: <4AD3032B.4090801@itp.phys.ethz.ch>
# In-Reply-To: <4AD3032B.4090801@itp.phys.ethz.ch>
# Content-Type: text/plain; charset=ISO-8859-1; format=flowed
# Content-Transfer-Encoding: 7bit
# Status:  O
# Dear Prof. Wuertz,
# Thank you for your message and your interest in my adaptive integration
# Fortran code. I would be pleased if you included my code in your open
# source R package under the Gnu GPL2 license. You have my permission to 
# do this.
# Sincerely,
# Alan Genz


################################################################################


adapt <- 
function (ndim, lower, upper, minpts = 100, maxpts = NULL,
    functn, eps = 0.01, ...)
{
    keep.trying <- is.null(maxpts)

    if (ndim == 1) { ## fudge for 1-d functions
    warning("Using integrate() from base package for 1-d integration")
        if (keep.trying) maxpts <- minpts
    return(integrate(functn,lower,upper,subdivisions=maxpts,rel.tol=eps,...))
    }
    ## else ndim >= 2 :

    ## Check to make sure that upper and lower are reasonable lengths
    ## Both the upper and lower limits should be at least of length ndim
    if (length(lower) < ndim || length(upper) < ndim)#MM: dropped 'at least':
    stop(paste("The lower and upper vectors need to have ndim elements\n",
           "Your parameters are:  ndim", ndim, ", length(lower)",
           length(lower), ", length(upper)", length(upper), "\n"))
    ff <-
    if(length(list(...)) && length(formals(functn)) > 1)
        function(x) functn(x, ...)
    else functn # .Alias
    rulcls <- 2^ndim + 2*ndim^2 + 6*ndim + 1 #-> ../src/adapt.f

    ## maxpts should be large enough.  Prefer 10*rulclc, but use 2*rulclc.
    if (keep.trying)
        maxpts <- max(minpts, 500, 2 * rulcls)
    else {
        if (minpts >= maxpts) {
            warning(paste("maxpts must be > minpts.\n",
                          "Maxpts has be increased to  minpts + 1"))
            maxpts <- minpts + 1
        }
        ##
        if (maxpts < 2 * rulcls) {
            warning(paste(
                "You have maxpts (= ", maxpts, ") too small\n",
                "It needs to be at least 2 times 2^ndim + 2*ndim^2 + 6*ndim+1\n",
                "It has been reset to ", 2 * rulcls, "\n", sep=""))
            maxpts <- 2 * rulcls
        }
    }

    repeat {
    lenwrk <- (2*ndim + 3)* (1 + maxpts/rulcls)/2# mandated in adapt source

    x <- .C("cadapt",
        as.integer(ndim),
        as.double(lower),
        as.double(upper),
        minpts = as.integer(minpts),
        maxpts = as.integer(maxpts),
        ## now pass ff and current environment
        ff, rho = environment(),
        as.double(eps),
        relerr = double(1),
        lenwrk = as.integer(lenwrk),
        value = double(1),    # will contain the value of the integral
        ifail = integer(1),
        PACKAGE = "fMultivar")[
            c("value", "relerr", "minpts", "lenwrk", "ifail")]

    if (x$ifail == 1 && keep.trying)
        maxpts <- maxpts*2
    else
        break
    }
    if(x$ifail)
    warning(x$warn <-
        c("Ifail=1, maxpts was too small. Check the returned relerr!",
          paste("Ifail=2, lenwrk was too small. -- fix adapt() !\n",
            "Check the returned relerr!"),
          "Ifail=3: ndim > 20 -- rewrite the fortran code ;-) !",
          "Ifail=4, minpts > maxpts; should not happen!",
          "Ifail=5, internal non-convergence; should not happen!"
          )[x$ifail])

    # class(x) <- "integration"
    
    # Return Value:
    x
}


# ------------------------------------------------------------------------------


# print.integration <- function(x, ...) {
#     print(noquote(sapply(x, format, ...)),...)
#     invisible(x)
#}


################################################################################

CDW The multivariate integration package adapt was added to for use in the 
CDW Rmetrics package fCopula. Thanks to Prof. Alan Genz who put his code 
CDW for the use in fCopulae under the GPL-2 License.
CDW Message-ID: <4AD7A74B.3020108@math.wsu.edu>
CDW Date: Thu, 15 Oct 2009 15:50:51 -0700
CDW From: Alan Genz <genz@math.wsu.edu>
CDW User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.21) 
CDW     Gecko/20090402 SeaMonkey/1.1.16
CDW MIME-Version: 1.0
CDW To: Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
CDW CC: Alan C Genz <alangenz@wsu.edu>
CDW Subject: Re: adapt
CDW References: <4AD3032B.4090801@itp.phys.ethz.ch>
CDW In-Reply-To: <4AD3032B.4090801@itp.phys.ethz.ch>
CDW Content-Type: text/plain; charset=ISO-8859-1; format=flowed
CDW Content-Transfer-Encoding: 7bit
CDW Status:  O
CDW Dear Prof. Wuertz,
CDW Thank you for your message and your interest in my adaptive integration
CDW Fortran code. I would be pleased if you included my code in your open
CDW source R fCopulae package under the Gnu GPL2 license. You have my
CDW permission to do this.
CDW Sincerely,
CDW Alan Genz 


cMM this is the original adapt code with one modification.
cMM instead of calling the external function "functn", a fixed
cMM external routine adphlp is always called, and passed a pointer
cMM to the external s function.
cMM                              Michael Meyer, October 1989.

      subroutine adapt(ndim,a,b,minpts,maxpts,eps,relerr,
     *         lenwrk,wrkstr,finest,ifail)
c***begin prologue adapt
c  adaptive multidimensional integration subroutine
c          author: A. C. Genz, Washington State University
c                 19 March 1984
c**************       parameters for adapt  ********************************
c***** input parameters
c  ndim         number of variables, must exceed 1, but not exceed 20
c  a         real array of lower limits, with dimension ndim
c  b         real array of upper limits, with dimension ndim
c  minpts  minimum number of function evaluations to be allowed.
c         on the first call to adapt minpts should be set to a
c         non negative value (caution... minpts is altered by adapt).
c         It is possible to continue a calculation to greater accuracy
c         by calling adapt again by decreasing eps (described below)
c         and resetting minpts to any negative value.
c         minpts must not exceed maxpts.
c  maxpts  maximum number of function evaluations to be allowed,
c         which must be at least rulcls, where
c         rulcls =  2**ndim+2*ndim**2+6*ndim+1
c
c             for ndim =  2   3   4   5   6   7   8   9   10      12    15      20
c      maxpts >= rulcls = 25  45  73 113 173 269 433 729 1285 4457 33309 1049497
c
c        a SUGGESTED value for maxpts is 100 times the above values.
c
c  functn  externally declared user defined function to be integrated.
c         it must have parameters (ndim,z), where z is a real array
c         of dimension ndim.
cTSL this function has been replaced by the fixed function adhlp
c  eps         required relative accuracy
c  lenwrk  length of array wrkstr of working storage, the routine
c         needs (2*ndim+3)*(1+maxpts/rulcls)/2 for lenwrk if
c         maxpts function calls are used.
c         for guidance, if you set maxpts to 100*rulcls (see table
c         above) then acceptable values for lenwrk are
c
c           for ndim = 2    3        4    5    6       7    8          9
c           lenwrk =  357  561       1785 3417 6681 13209 26265 52377
c
c***** OUTPUT parameters
c
c  minpts  actual number of function evaluations used by adapt
c  wrkstr  real array of working storage of dimension (lenwrk).
c  relerr  estimated relative accuracy of finest
c  finest  estimated value of integral ["FINal ESTimate"]
c  ifail : return code
c
c      ifail=0 for normal exit, when estimated relative accuracy
c            relerr is less than eps with maxpts or less function
c            calls made.
c      ifail=1 if maxpts was too small for adapt to obtain the
c            required relative accuracy eps.
c            In this case adapt returns a value of finest
c            with estimated relative accuracy relerr.
c      ifail=2 if lenwrk too small for maxpts function calls.
c            In this case adapt returns a value of finest with
c            estimated accuracy relerr using the working storage
c            available, but relerr will be greater than eps.
c      ifail=3 if ndim < 2, ndim > 20,
c      ifail=4 if minpts > maxpts,
c      ifail=5 if maxpts < rulcls or other memory problems
c                  (which will only be found later)
c***********************************************************************
c***end prologue adapt

      implicit none

C-- Arguments:
C      double precision functn
C      external functn

      integer ndim, minpts,maxpts, lenwrk, ifail
      double precision a(ndim), b(ndim), eps, relerr, wrkstr(lenwrk),
     &         finest

C-- Local Variables:
      double precision center(20), width(20)
      double precision errmin, rgnerr, rgnval, half, zero,one,two

      integer divaxo, divaxn, divflg, funcls, index1, index2,
     *     j, k,  maxcls, rgnstr, rulcls, sbrgns, sbtmpp, subrgn, subtmp

      data zero/0d0/, one/1d0/, two/2d0/

c Check arguments; fail w/ code '3' or '4'
      relerr=one
      funcls=0
      ifail=3
      if(ndim.lt.2.or.ndim.gt.20) goto 990
      ifail=4
      if(minpts.gt.maxpts) goto 990
      ifail=5
c
c*****      initialisation of subroutine
c
      half=one/two
      rgnstr =2*ndim+3
      errmin = zero
      maxcls = 2**ndim + 2*ndim**2 + 6*ndim+1
      maxcls = min0(maxcls,maxpts)
      divaxo=0
c
c*****      end subroutine initialisation
      if(minpts.lt.0) then
         sbrgns=wrkstr(lenwrk-1)
         goto 280
      endif

      do 30 j=1,ndim
       width(j)=(b(j)-a(j))*half
 30       center(j)=a(j)+width(j)
      finest=zero
      wrkstr(lenwrk)=zero
      divflg=1
      subrgn=rgnstr
      sbrgns=rgnstr

C-- REPEAT --- (outermost loop) -------
   40 call bsrl(ndim,center,width,maxcls,rulcls,
     *         errmin,rgnerr,rgnval,divaxo,divaxn)
      finest=finest+rgnval
      wrkstr(lenwrk)=wrkstr(lenwrk)+rgnerr
      funcls = funcls + rulcls
c
c*****      place results of basic rule into partially ordered list
c*****      according to subregion error
      if(divflg .eq. 0) then
c
c*****      when divflg=0 start at top of list and move down list tree to
c     find correct position for results from first half of recently
c     divided subregion
 200       subtmp=2*subrgn
       if(subtmp.le.sbrgns) then
          if(subtmp.ne.sbrgns) then
             sbtmpp=subtmp+rgnstr
             if(wrkstr(subtmp).lt.wrkstr(sbtmpp)) subtmp=sbtmpp
          endif
 210          if(rgnerr.lt.wrkstr(subtmp)) then
             do 220 k=1,rgnstr
              index1=subrgn-k+1
              index2=subtmp-k+1
              wrkstr(index1)=wrkstr(index2)
 220             continue
             subrgn=subtmp

             goto 200
          endif
       endif

      else
c
c*****when divflg=1 start at bottom right branch and move up list
c     tree to find correct position for results from second half of
c     recently divided subregion
 230       subtmp=(subrgn/(rgnstr*2))*rgnstr
       if(subtmp.ge.rgnstr) then
          if(rgnerr.gt.wrkstr(subtmp)) then
             do 240 k=1,rgnstr
              index1=subrgn-k+1
              index2=subtmp-k+1
              wrkstr(index1)=wrkstr(index2)
 240             continue
             subrgn=subtmp
             goto 230
          endif
       endif
      endif

c*****      store results of basic rule in correct position in list
  250 wrkstr(subrgn)=rgnerr
      wrkstr(subrgn-1)=rgnval
      wrkstr(subrgn-2)=divaxn
      do 260 j=1,ndim
      subtmp=subrgn-2*(j+1)
      wrkstr(subtmp+1)=center(j)
      wrkstr(subtmp)=width(j)
 260  continue
      if(divflg .eq. 0) then
c***  when divflg=0 prepare for second application of basic rule
       center(divaxo)=center(divaxo)+two*width(divaxo)
       sbrgns=sbrgns+rgnstr
       subrgn=sbrgns
       divflg=1
c***  loop back to apply basic rule to other half of subregion
       go to 40
      endif
c
c*****      end ordering and storage of basic rule results
c*****      make checks for possible termination of routine
c
  270 relerr=one
      if(wrkstr(lenwrk).le.zero) wrkstr(lenwrk)=zero
      if(dabs(finest).ne.zero) relerr=wrkstr(lenwrk)/dabs(finest)
      if(relerr.gt.one) relerr=one

      if(sbrgns+rgnstr.gt.lenwrk-2) ifail=2
      if(funcls+funcls*rgnstr/sbrgns.gt.maxpts) ifail=1
      if(relerr.lt.eps.and.funcls.ge.minpts) ifail=0
      if(ifail.lt.3) goto 990
c
c*****      prepare to use basic rule on each half of subregion with largest
c      error
  280 divflg=0
      subrgn=rgnstr
      subtmp = 2*sbrgns/rgnstr
      maxcls = maxpts/subtmp
      errmin = dabs(finest)*eps/dfloat(subtmp)
      wrkstr(lenwrk)=wrkstr(lenwrk)-wrkstr(subrgn)
      finest=finest-wrkstr(subrgn-1)
      divaxo=wrkstr(subrgn-2)
      do 290 j=1,ndim
      subtmp=subrgn-2*(j+1)
      center(j)=wrkstr(subtmp+1)
  290      width(j)=wrkstr(subtmp)
      width(divaxo)=width(divaxo)*half
      center(divaxo)=center(divaxo)-width(divaxo)
c
c*****      loop back to apply basic rule
c
      goto 40
c
c*****      termination point
c
  990 minpts=funcls
      wrkstr(lenwrk-1)=sbrgns
      return
      end
      subroutine bsrl(s, center,hwidth, maxvls,funcls,
     *                  errmin,errest,basest,divaxo,divaxn)

      implicit none
C-- Arguments:
      integer s
      double precision center(s), hwidth(s)
      integer maxvls,funcls, divaxo,divaxn
      double precision errmin, errest, basest
C
      EXTERNAL adphlp
      double precision adphlp
C-- Local Variables:
      double precision  intvls(20), z(20), fulsms(200), weghts(200)

      integer intcls, i, mindeg, maxdeg, maxord, minord
      integer ifail

      double precision zero, one, two, ten, dif, errorm,
     *     sum0, sum1, sum2, difmax, x1, x2

      data zero/0d0/, one/1d0/, two/2d0/, ten/10d0/

      maxdeg = 12
      mindeg = 4
      minord = 0
      do 10 maxord = mindeg,maxdeg
         call symrl(s, center, hwidth, minord, maxord, intvls,
     *        intcls, 200, weghts, fulsms, ifail)
         if (ifail.eq.2) goto 20
         errest = dabs(intvls(maxord)  -intvls(maxord-1))
         errorm = dabs(intvls(maxord-1)-intvls(maxord-2))
         if (errest.ne.zero)
     &        errest = errest*
     &        dmax1(one/ten,errest/dmax1(errest/two,errorm))
         if (errorm.le. 5.*errest) goto 20
         if (2*intcls.gt.maxvls) goto 20
         if (errest.lt.errmin) goto 20
 10   continue
 20   difmax = -1
      x1 = one/two**2
      x2 = 3.*x1
      do 30 i = 1,s
         z(i) = center(i)
 30   continue
cmmm
      sum0 = adphlp(s,z)
      do 40 i = 1,s
         z(i) = center(i) - x1*hwidth(i)
cmmm
         sum1 = adphlp(s,z)
         z(i) = center(i) + x1*hwidth(i)

         sum1 = sum1 + adphlp(s,z)
         z(i) = center(i) - x2*hwidth(i)

         sum2 = adphlp(s,z)
         z(i) = center(i) + x2*hwidth(i)

         sum2 = sum2 + adphlp(s,z)
         z(i) = center(i)

         dif = dabs((sum1-two*sum0) - (x1/x2)**2*(sum2-two*sum0))
         if (dif.ge.difmax) then
            difmax = dif
            divaxn = i
         endif
 40   continue
      if (sum0.eq.sum0+difmax/two) divaxn = mod(divaxo,s) + 1
      basest = intvls(minord)
      funcls = intcls + 4*s
      return
      end
      double precision function flsm(s,center,hwidth,x,m,mp,maxord,
     * g,sumcls)
c
c***  function to compute fully symmetric basic rule sum
c
      integer s, m(s), mp(s), maxord, sumcls, ixchng, lxchng, i, l,
     * ihalf, mpi, mpl
      double precision g(maxord), x(s), intwgt, zero, one,two, intsum,
     * center(s), hwidth(s)
      double precision adphlp

      zero = 0
      one = 1
      two = 2

      intwgt = one
      do 10 i=1,s
        mp(i) = m(i)
        if (m(i).ne.0) intwgt = intwgt/two
        intwgt = intwgt*hwidth(i)
   10 continue
      sumcls = 0
      flsm = zero
c
c*******  compute centrally symmetric sum for permutation mp
   20 intsum = zero
      do 30 i=1,s
        mpi = mp(i) + 1
        x(i) = center(i) + g(mpi)*hwidth(i)
   30 continue
   40 sumcls = sumcls + 1
cmmm
      intsum = intsum + adphlp(s,x)
      do 50 i=1,s
        mpi = mp(i) + 1
        if(g(mpi).ne.zero) hwidth(i) = -hwidth(i)
        x(i) = center(i) + g(mpi)*hwidth(i)
        if (x(i).lt.center(i)) go to 40
   50 continue
c*******  end integration loop for mp
c
      flsm = flsm + intwgt*intsum
      if (s.eq.1) return
c
c*******  find next distinct permutation of m and loop back
c          to compute next centrally symmetric sum
      do 80 i=2,s
        if (mp(i-1).le.mp(i)) go to 80
        mpi = mp(i)
        ixchng = i - 1
        if (i.eq.2) go to 70
        ihalf = ixchng/2
        do 60 l=1,ihalf
          mpl = mp(l)
          imnusl = i - l
          mp(l) = mp(imnusl)
          mp(imnusl) = mpl
          if (mpl.le.mpi) ixchng = ixchng - 1
          if (mp(l).gt.mpi) lxchng = l
   60   continue
        if (mp(ixchng).le.mpi) ixchng = lxchng
   70   mp(i) = mp(ixchng)
        mp(ixchng) = mpi
        go to 20
   80 continue
c*****  end loop for permutations of m and associated sums
c
      return
      end
      subroutine nxprt(prtcnt, s, m)
c
c***  subroutine to compute the next s partition
c
      implicit none
      integer s, m(s), prtcnt

      integer i,k, msum

      if (prtcnt.gt.0) go to 20
      do 10 i=1,s
        m(i) = 0
   10 continue
      prtcnt = 1
      return
   20 prtcnt = prtcnt + 1
      msum = m(1)
      if (s.eq.1) go to 60
      do 50 i=2,s
        msum = msum + m(i)
        if (m(1).le.m(i)+1) go to 40
        m(1) = msum - (i-1)*(m(i)+1)
        do 30 k=2,i
          m(k) = m(i) + 1
   30   continue
        return
   40   m(i) = 0
   50 continue
   60 m(1) = msum + 1
      return
      end
      subroutine symrl(s, center, hwidth, minord, maxord, intvls,
     *     intcls, numsms, weghts, fulsms, fail)
c  multidimensional fully symmetric rule integration subroutine
c
c   this subroutine computes a sequence of fully symmetric rule
c   approximations to a fully symmetric multiple integral.
c   written by a. genz, mathematical institute, university of kent,
c   canterbury, kent ct2 7nf, england
c
c**************       parameters for symrl  ********************************
c*****input parameters
c  s         integer number of variables, must exceed 0 but not exceed 20
c  f         externally declared user defined real function integrand.
c         it must have parameters (s,x), where x is a real array
c         with dimension s.
c  minord  integer minimum order parameter.  on entry minord specifies
c         the current highest order approximation to the integral,
c         available in the array intvls.  for the first call of symrl
c         minord should be set to 0.  otherwise a previous call is
c         assumed that computed intvls(1), ... , intvls(minord).
c         on exit minord is set to maxord.
c  maxord  integer maximum order parameter, must be greater than minord
c         and not exceed 20. the subroutine computes intvls(minord+1),
c         intvls(minord+2),..., intvls(maxord).
c  g         real array of dimension(maxord) of generators.
c         all generators must be distinct and nonnegative.
c  numsms  integer length of array fulsms, must be at least the sum of
c         the number of distinct partitions of length at most s
c         of the integers 0,1,...,maxord-1.  an upper bound for numsms
c         when s+maxord is less than 19 is 200
c******output parameters
c  intvls  real array of dimension(maxord).  upon successful exit
c         intvls(1), intvls(2),..., intvls(maxord) are approximations
c         to the integral.  intvls(d+1) will be an approximation of
c         polynomial degree 2d+1.
c  intcls  integer total number of f values needed for intvls(maxord)
c  weghts  real working storage array with dimension (numsms). on exit
c         weghts(j) contains the weight for fulsms(j).
c  fulsms  real working storage array with dimension (numsms). on exit
c         fulsms(j) contains the fully symmetric basic rule sum
c         indexed by the jth s-partition of the integers
c         0,1,...,maxord-1.
c  fail         integer failure output parameter
c         fail=0 for successful termination of the subroutine
c         fail=1 when numsms is too small for the subroutine to
c               continue.  in this case weghts(1), weghts(2), ...,
c               weghts(numsms), fulsms(1), fulsms(2), ...,
c               fulsms(numsms) and intvls(1), intvls(2),...,
c               intvls(j) are returned, where j is maximum value of
c               maxord compatible with the given value of numsms.
c         fail=2 when parameters s,minord, maxord or g are out of
c               range
c***********************************************************************
cmmm        external f
ctsl      real f
ctsl       double precision f
c***  for double precision change real to double precision
c      in the next statement
      integer d, i, fail, k(20), intcls, prtcnt, l, m(20), maxord,
     * minord, modofm, numsms, s, sumcls
      double precision intvls(maxord), center(s), hwidth(s), gisqrd,
     * glsqrd,
     * intmpa, intmpb, intval, one, fulsms(numsms), weghts(numsms),
     * two, momtol, momnkn, momprd(20,20), moment(20), zero, g(20)
      double precision flsm, wht
c      patterson generators
      data g(1), g(2) /0.0000000000000000,0.7745966692414833/
      data g(3), g(4) /0.9604912687080202,0.4342437493468025/
      data g(5), g(6) /0.9938319632127549,0.8884592328722569/
      data g(7), g(8) /0.6211029467372263,0.2233866864289668/
      data g(9), g(10), g(11), g(12) /0.1, 0.2, 0.3, 0.4/
c
c***  parameter checking and initialisation
      fail = 2
      maxrdm = 20
      maxs = 20
      if (s.gt.maxs .or. s.lt.1) return
      if (minord.lt.0 .or. minord.ge.maxord) return
      if (maxord.gt.maxrdm) return
      zero = 0
      one = 1
      two = 2
      momtol = one
   10 momtol = momtol/two
      if (momtol+one.gt.one) go to 10
      hundrd = 100
      momtol = hundrd*two*momtol
      d = minord
      if (d.eq.0) intcls = 0
c***  calculate moments and modified moments
      do 20 l=1,maxord
      floatl = l + l - 1
      moment(l) = two/floatl
   20 continue
      if (maxord.ne.1) then
         do 40 l=2,maxord
            intmpa = moment(l-1)
            glsqrd = g(l-1)**2
            do 30 i=l,maxord
               intmpb = moment(i)
               moment(i) = moment(i) - glsqrd*intmpa
               intmpa = intmpb
 30         continue
            if (moment(l)**2.lt.(momtol*moment(1))**2) moment(l) = zero
 40      continue
      endif
      do 70 l=1,maxord
      if (g(l).lt.zero) return
      momnkn = one
      momprd(l,1) = moment(1)
      if (maxord.eq.1) go to 70
      glsqrd = g(l)**2
      do 60 i=2,maxord
        if (i.le.l) gisqrd = g(i-1)**2
        if (i.gt.l) gisqrd = g(i)**2
        if (glsqrd.eq.gisqrd) return
        momnkn = momnkn/(glsqrd-gisqrd)
        momprd(l,i) = momnkn*moment(i)
   60      continue
   70 continue
      fail = 1
c
c***  begin LOOP
c      for each d find all distinct partitions m with mod(m))=d
c
   80 prtcnt = 0
      intval = zero
      modofm = 0
      call nxprt(prtcnt, s, m)
   90 if (prtcnt.gt.numsms) return
c
c***  calculate weight for partition m and fully symmetric sums
c***       when necessary
c
      if (d.eq.modofm) weghts(prtcnt) = zero
      if (d.eq.modofm) fulsms(prtcnt) = zero
      fulwgt = wht(s,moment,m,k,modofm,d,maxrdm,momprd)
      sumcls = 0
      if (weghts(prtcnt).eq.zero .and. fulwgt.ne.zero) fulsms(prtcnt) =
     * flsm(s, center, hwidth, moment, m, k, maxord, g, sumcls)
      intcls = intcls + sumcls
      intval = intval + fulwgt*fulsms(prtcnt)
      weghts(prtcnt) = weghts(prtcnt) + fulwgt
      call nxprt(prtcnt, s, m)
      if (m(1).gt.modofm) modofm = modofm + 1
      if (modofm.le.d) go to 90
c
c***  end loop for each d
      if (d.gt.0) intval = intvls(d) + intval
      intvls(d+1) = intval
      d = d + 1
      if (d.lt.maxord) go to 80
c
c***  set failure parameter and return
      fail = 0
      minord = maxord
      return
      end
      double precision function wht(s, intrps, m, k, modofm, d,
     *     maxrdm, momprd)
c***  subroutine to calculate weight for partition m
c
      integer s, m(s), k(s), d, maxrdm, mi, ki, m1, k1, modofm
      double precision intrps(s), zero, momprd(maxrdm,maxrdm)

      zero = 0
      do 10 i=1,s
        intrps(i) = zero
        k(i) = 0
   10 continue
      m1 = m(1) + 1
      k1 = d - modofm + m1
   20 intrps(1) = momprd(m1,k1)
      if (s.eq.1) go to 40
      do 30 i=2,s
        mi = m(i) + 1
        ki = k(i) + mi
        intrps(i) = intrps(i) + momprd(mi,ki)*intrps(i-1)
        intrps(i-1) = zero
        k1 = k1 - 1
        k(i) = k(i) + 1
        if (k1.ge.m1) go to 20
        k1 = k1 + k(i)
        k(i) = 0
   30 continue
   40 wht = intrps(s)
      return
      end

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA


################################################################################
# FUNCTION:           DESCRIPTION:
#  gridData            Generates a grid data set
#  persp.gridData      Generates a perspective plot from a grid data object
#  contour.gridData    Generates a contour plot from a grid data object
# REQUIREMENT:        DESCRIPTION:
#  akima               Package
#  spatial             Package
################################################################################


test.gridData = 
    function()
{
    #  gridData            Generates a grid data set
    #  persp.gridData      Generates a perspective plot from a grid data object
    #  contour.gridData    Generates a contour plot from a grid data object
     
    # Generate Grid Data:
    gD <- gridData()
    
    # Perspective Plot:
    persp(gD)
    
    # Contour Plot:
    contour(gD) 
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------
## Cannot be checked on CRAN because of the akima library

# test.gridDataPlot = 
#     function()
# {   
#     #  gridData            Generates a grid data set
#     #  persp.gridData      Generates a perspective plot from a grid data object
#     #  contour.gridData    Generates a contour plot from a grid data object
#       
#     # Generate Akima interpolated Grid Data:
#     # Does not run for r-solaris-x86
#     if (FALSE) {
#       require(akima)
#       RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
#       set.seed(4711, kind = "Marsaglia-Multicarry")
#       x = runif(999)-0.5
#       y = runif(999)-0.5
#       z = cos(2*pi*(x^2+y^2))
#       ans = akimaInterp(x, y, z, extrap = FALSE)
#       persp(ans)
#       title(main = "Akima Interpolation") 
#       contour(ans)
#       title(main = "Akima Interpolation")
#     }
#     
#     # Generate Kriged Grid Data:
#     require(spatial)
#     RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
#     set.seed(4711, kind = "Marsaglia-Multicarry")
#     x = runif(999)-0.5
#     y = runif(999)-0.5
#     z = cos(2*pi*(x^2+y^2))
#     ans = krigeInterp(x, y, z, extrap = FALSE)
#     persp(ans)
#     title(main = "Kriging") 
#     contour(ans)
#     title(main = "Kriging") 
#     
#     # Return Value:
#     return()    
# }


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA


################################################################################
# FUNCTION:           DESCRIPTION:
#  squareBinning       Square binning of irregularly distributed data sets
#  plot                S3 Method for plotting square binned data sets
# FUNCTION:           DESCRIPTION:
#  hexBinning          Hexagonal binning of irregularly distributed data sets
#  plot                S3 Method for plotting hexagonal binned data sets
################################################################################


test.squareBinning = 
function()
{
    #  squareBinning    Square binning of irregularly distributed data sets
    #  plot             S3 Method for plotting square binned data sets

    # Generate Grid Data:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    sB = squareBinning(x = rnorm(1000), y = rnorm(1000))
    
    # Plot:
    par(mfrow = c(1, 1))
    plot(sB)
    title(main = "Square Binning")
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.hexBinning = 
function()
{
    #  hexBinning       Hexagonal binning of irregularly distributed data sets
    #  plot             S3 Method for plotting hexagonal binned data sets
    
    # Generate Grid Data:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    hB = hexBinning(x = rnorm(1000), y = rnorm(1000))
    
    # Plot:
    par(mfrow = c(1, 1))
    plot(hB)
    title(main = "Hexagonal Binning")
      
    # Return Value:
    return()    
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file 


################################################################################
# FUNCTION:           DESCRIPTION:
#  squareBinning       Square binning of irregularly distributed data sets
#  plot                S3 Method for plotting square binned data sets
# FUNCTION:           DESCRIPTION:
#  hexBinning          Hexagonal binning of irregularly distributed data sets
#  plot                S3 Method for plotting hexagonal binned data sets
################################################################################


test.squareBinning = 
function()
{
    #  squareBinning    Square binning of irregularly distributed data sets
    #  plot             S3 Method for plotting square binned data sets

    # Generate Grid Data:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    sB = squareBinning(x = rnorm(1000), y = rnorm(1000))
    
    # Plot:
    par(mfrow = c(1, 1))
    plot(sB)
    title(main = "Square Binning")
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.hexBinning = 
function()
{
    #  hexBinning       Hexagonal binning of irregularly distributed data sets
    #  plot             S3 Method for plotting hexagonal binned data sets
    
    # Generate Grid Data:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    hB = hexBinning(x = rnorm(1000), y = rnorm(1000))
    
    # Plot:
    par(mfrow = c(1, 1))
    plot(hB)
    title(main = "Hexagonal Binning")
      
    # Return Value:
    return()    
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port: 
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:           DESCRIPTION:
#  dmvsnorm            Multivariate Skew Normal Density Function
#  pmvsnorm            Multivariate Skew Normal Probability Function
#  rmvsnorm            Multivariate Skew Normal Random Deviates
# FUNCTION:           DESCRIPTION:
#  dmvst               Multivariate Skew Sudent-t Density Function
#  pmvst               Multivariate Skew Sudent-t Probability Function
#  rmvst               Multivariate Skew Sudent-t Random Deviates
# FUNCTION:           DESCRIPTION:
#  fMV                 S4 Object of class 'fMV'
#  mvFit               Fits a MV Normal or Student-t Distribution
#  print.fMV           S3: Print method for objects of class 'fMV'
#  plot.fMV            S3: Plot method for objects of class 'fMV'
#  summary.fMV         S3: Summary method for objects of class 'fMV'
################################################################################


test.dmvsnorm =
function()
{
    # Multivariate Skew Normal
    
    # Bivariate Density:
    x = y = seq(-4, 4, length = 81)
    G = grid2d(x)
    X = cbind(G$x, G$y)
    z = dmvsnorm(X, dim = 2, mu = rep(0, 2), Omega = diag(2), alpha = rep(0, 2))
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    
    # Plot:
    par(mfrow = c(1, 1), ask = FALSE)
    persp(Z, theta = -40, phi = 30, col = "steelblue")
       
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.pmvsnorm =
function()
{
    # Multivariate Skew Normal
    
    # Bivariate Density:
    x = y = seq(-4, 4, length = 21)
    G = grid2d(x)
    X = cbind(G$x, G$y)
    z = pmvsnorm(X, dim = 2, mu = rep(0, 2), Omega = diag(2), alpha = rep(0, 2))
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    
    # Plot:
    par(mfrow = c(1, 1), ask = FALSE)
    persp(Z, theta = -40, phi = 30, col = "steelblue")
       
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.rmvsnorm =
function()
{
    # Multivariate Skew Normal
    
    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    N = 5000
    z = rmvsnorm(N, dim = 2, mu = rep(0, 2), Omega = diag(2), alpha = rep(1, 2))
    
    # Scatterplot:
    par(mfrow = c(1, 1), ask = FALSE)
    plot(z, pch = 19, col = "steelblue")
    grid()
       
    # Return Value:
    return()    
}


################################################################################


test.dmvst =
function()
{
    # Multivariate Skew Sudent-t
    args(dmvst)
    # dmvst(x, dim = 2, mu = rep(0, dim), Omega = diag(dim), 
    #   alpha = rep(0, dim), df = 4) 

    # Bivariate Density:
    x = y = seq(-4, 4, length = 81)
    G = grid2d(x)
    X = cbind(G$x, G$y)
    z = dmvst(X, dim = 2, mu = rep(0, 2), Omega = diag(2), alpha = c(-1, 1))
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    
    # Plot:
    par(mfrow = c(1, 1), ask = FALSE)
    persp(Z, theta = -40, phi = 30, col = "steelblue")
       
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.pmvst =
function()
{
    # Multivariate Skew Sudent-t
    
    # Bivariate Density:
    x = y = seq(-4, 4, length = 21)
    G = grid2d(x)
    X = cbind(G$x, G$y)
    z = pmvst(X, dim = 2, mu = rep(0, 2), Omega = diag(2), alpha = c(-1, 1))
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    
    # Plot:
    par(mfrow = c(1, 1), ask = FALSE)
    persp(Z, theta = -40, phi = 30, col = "steelblue")
    .perspPlot(Z)
       
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.rmvst =
function()
{
    # Multivariate Skew Sudent-t
    
    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    N = 5000
    z = rmvsnorm(N, dim = 2, mu = rep(0, 2), Omega = diag(2), alpha = c(-1, 1))
    
    # Scatterplot:
    par(mfrow = c(1, 1), ask = FALSE)
    plot(z, pch = 19, col = "steelblue")
    grid()
       
    # Return Value:
    return()    
}


################################################################################


#  fMV                 S4 Object of class 'fMV'


################################################################################


test.mvFit.mvsnorm =
function()
{
    # mvFit - Fits a MV Normal or Student-t Distribution
    # mvFit(x, method = c("snorm", "st"), fixed.df = NA, title = NULL, 
    #   description = NULL, trace = FALSE, ...) 

    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    N = 5000
    z = rmvsnorm(N, dim = 2, mu = rep(0, 2), Omega = diag(2), alpha = c(-1, 1))
    
    # Fit:
    fit = mvFit(x = z, method = "snorm")
    
    # Print:
    print(fit)
    
    # Interactive Plot:
    # plot(fit, which = "ask")
    
    # Scatterplot:
    par(mfrow = c(1, 1))
    plot(fit, which = 1)
    
    # Normal QQ Plot of Mahalanobis Distances:
    par(mfrow = c(2, 2))
    plot(fit, which = 2)
    
    # Skew Normal QQ Plot of Mahalanobis Distances:
    plot(fit, which = 3)
    
    # Normal PP Plot of Mahalanobis Distances:
    plot(fit, which = 4)
    
    # Skew Normal PP Plot of Mahalanobis Distances:
    plot(fit, which = 5)
       
    # Summary:
    summary(fit, doplot = FALSE)

    # Return Value:
    return()    
}


################################################################################


test.mvFit.mvst =
function()
{
    # mvFit - Fits a MV Normal or Student-t Distribution
    # mvFit(x, method = c("snorm", "st"), fixed.df = NA, title = NULL, 
    #   description = NULL, trace = FALSE, ...) 

    # RVs:
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    N = 1000
    z = rmvst(N, dim = 2, mu = rep(0, 2), Omega = diag(2), alpha = c(-1, 1), 
        df = 4)
    
    # Fit:
    # fit = mvFit(x = z, method = "st", trace = TRUE)       
    fit = mvFit(x = z, method = "st")                    

    # Print:
    print(fit)
    
    # Interactive Plot:
    # plot(fit, which = "ask")
    
    # Scatterplot:
    par(mfrow = c(1, 1))
    plot(fit, which = 1)
    
    # Normal QQ Plot of Mahalanobis Distances:
    par(mfrow = c(2, 2))
    plot(fit, which = 2)
    
    # Skew Normal QQ Plot of Mahalanobis Distances:
    plot(fit, which = 3)
    
    # Normal PP Plot of Mahalanobis Distances:
    plot(fit, which = 4)
    
    # Skew Normal PP Plot of Mahalanobis Distances:
    plot(fit, which = 5)
       
    # Summary:
    summary(fit, doplot = FALSE)

    # Return Value:
    return()    
}


################################################################################
    

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA

# Copyrights (C)
# for this R-port:
#   1999 - 2007, Diethelm Wuertz, GPL
#   Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
#   info@rmetrics.org
#   www.rmetrics.org
# for the code accessed (or partly included) from other R-ports:
#   see R's copyright and license files
# for the code accessed (or partly included) from contributed R-ports
# and other sources
#   see Rmetrics's copyright file


################################################################################
# FUNCTION:             BIVARIATE CAUCHY DISTRIBUTION:
#  pcauchy2d             Computes bivariate Cauchy probability function
#  dcauchy2d             Computes bivariate Cauchy density function
#  rcauchy2d             Generates bivariate Cauchy random deviates
################################################################################


pcauchy2d =
function(x, y = x, rho = 0)
{   # A function Implemented by Diethelm Wuertz

    # Description:
    #   Computes bivariate Cauchy probability function

    # Arguments:
    #   x, y - two numeric values or vectors of the same length at
    #       which the probability will be computed.

    # Example:
    #   pt2d(rnorm(5), rnorm(5), 0.5, 5)

    # Value:
    #   returns a numeric vector of probabilities of the same length
    #   as the input vectors

    # FUNCTION:

    # Settings:
    # Probaility:
    ans  = pt2d(x = x, y = y, rho = rho, nu = 1)
    attr(ans, "control") = c(rho = rho)

    # Return Value:
    ans
}


# ------------------------------------------------------------------------------


dcauchy2d =
function(x, y = x, rho = 0)
{   # A function implemented by Diethelm Wuertz

    # Arguments:
    #   n - number of random deviates to be generated
    #   rho - the linear correlation, a numeric value between
    #       minus one and one.

    # Description:
    #   Computes bivariate Cauchy density function

    # Note:
    #   Partly copied from contributed R package 'sn'

    # FUNCTION:

    # Density:
    density = dt2d(x = x, y = y, rho = rho, nu = 1)
    attr(density, "control") = c(rho = rho)

    # Return value:
    density
}


# ------------------------------------------------------------------------------


rcauchy2d =
function(n, rho = 0)
{   # A function implemented by Diethelm Wuertz

    # Description:
    #   Generates bivariate Cauchy random deviates

    # Arguments:
    #   n - number of random deviates to be generated
    #   rho - the linear correlation, a numeric value between
    #       minus one and one.

    # Note:
    #   Partly copied from contributed R package 'mvtnorm'
    #   Author Friedrich Leisch

    # FUNCTION:

    # Random Deviates:
    ans = rt2d(n = n, rho = rho, nu = 1)
    attr(ans, "control") = c(rho = rho)

    # Return Value:
    ans
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  integrate2d           Integrates over a two dimensional unit square
################################################################################


integrate2d <-  
    function(fun, error = 1.0e-5, ...)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   2-dimension quadrature rule on [0,1]^2 
    
    # Arguments:
    #   fun - function to be integrated. The first argument requests
    #       the x values, the second the y values, and the remaining
    #       are reserved for additional parameters.
    #   ... - parameters passed to the function to be integrated
    
    # Details:
    #   see: Abramowitz and Stegun, p. 892
    
    # FUNCTION:
    
    # Estimate a reasonable number of subintervals:
    H <- sqrt(sqrt(error))
    n <- ceiling(1/H + 1)
    blocks <- ceiling(log(n+1)/log(2))
    n <- 2^blocks-1
    h <- 1/(n-1)
    
    # The error will be of order h^4:
    error <- h^4
    
    # Create all grid coordinates:
    x <- y <- h*seq(1, n-1, by = 2)
    nx <- ny <- length(x)
    xoy <- cbind(rep(x, ny), as.vector(matrix(y, nx, ny, byrow = TRUE)))
    XY <- matrix(xoy, nx * ny, 2, byrow = FALSE)
    
    # The integration rule:      
    rule <- function(x, h, ...) {         
        X = x[1] + h*c(  0, -1, -1,  1,  1, -1,  1,  0,  0)
        Y = x[2] + h*c(  0, -1,  1, -1,  1,  0,  0, -1,  1)
        W =  c( 16,  1,  1,  1,  1,  4,  4,  4,  4)/36
        ans = sum( W * fun(X, Y, ...) )
    }
     
    # Result:
    ans <- (4*h^2)*sum(apply(XY, 1, rule, h = h, ...))
    
    # Return Value:
    list(value = ans, error = error, points = n)
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


###############################################################################
# FUNCTION:           DESCRIPTION:
#  dmvnorm             Multivariate Normal Density function
#  pmvnorm             Multivariate Normal Probability function
#  qmvnorm             Multivariate Equicoordinate Normal Quantile function
#  rmvnorm             Multivariate Normal Random Number generator
# REQUIRES:           DESCRIPTION:
#  mvtnorm             Contributed R-Package
################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################


.onAttach <- 
  function(libname, pkgname)
{
  # do whatever needs to be done when the package is loaded
  # some people use it to bombard users with 
  # messages using 

  # packageStartupMessage( "\n" )
  # packageStartupMessage( "Rmetrics Package fMultivar" ) 
  # packageStartupMessage( "Analysing and Modeling Multivariate Financial Return Distributions" )
  # packageStartupMessage( "Copyright (C) 2005-2014 Rmetrics Association Zurich" )  
  # packageStartupMessage( "Educational Software for Financial Engineering and Computational Science" ) 
  # packageStartupMessage( "Rmetrics is free software and comes with ABSOLUTELY NO WARRANTY." ) 
  # packageStartupMessage( "https://www.rmetrics.org --- Mail to: info@rmetrics.org" )
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


###############################################################################
# FUNCTION:           DESCRIPTION:
#  dmvt                Multivariate Student-t Density function
#  pmvt                Multivariate Student-t Probability function
#  qmvt                Multivariate Equicoordinate Student-t Quantile function
#  rmvt                Multivariate Student-t Random Nuber Generator
# REQUIREMENTS:       DESCRIPTION:
#  mvtnorm             Contributed R - Package
###############################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  grid2d                Returns from two vectors x-y grid coordinates
#  density2d             Returns 2D Kernel Density Estimates
#  hist2d                Returns 2D Histogram Counts
# FUNCTION:             BIVARIATE DISTRIBUTIONS:
#  pnorm2d               Computes bivariate Normal probability function
#  dnorm2d               Computes bivariate Normal density function
#  rnorm2d               Generates bivariate normal random deviates
#  pcauchy2d             Computes bivariate Cauchy probability function
#  dcauchy2d             Computes bivariate Cauchy density function
#  rcauchy2d             Generates bivariate Cauchy random deviates
#  pt2d                  Computes bivariate Student-t probability function
#  dt2d                  Computes bivariate Student-t density function
#  rt2d                  Generates bivariate Student-t random deviates
# FUNCTION:             ELLIPTICAL DISTRIBUTIONS:
#  delliptical2d         Computes density for elliptical distributions
# REQUIREMENTS:
#  fBasics::.perspPlot
#  fBasics::.contourPlot
################################################################################


test.grid2d =
function()
{
    # Grid Data:
    grid2d(x = (0:10)/10)
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.density2d =
    function()
{
    # Data:
    z <- rnorm2d(1000)
    
    # Density:
    D = density2d(x = z[, 1], y = z[, 2])
    .perspPlot(D)
    .contourPlot(D)
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.hist2d =
    function()
{
    # Data:
    z <- rnorm2d(1000)
   
    # Histogram:
    H <- hist2d(x = z[, 1], y = z[, 2])
    .perspPlot(H)
    .contourPlot(H)

    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.norm2d =
    function()
{
    #  pnorm2d - Computes bivariate Normal probability function
    #  dnorm2d - Computes bivariate Normal density function
    #  rnorm2d - Generates bivariate normal random deviates
    
    # Normal Density:
    x = (-40:40)/10
    X = grid2d(x)
    z = dnorm2d(X$x, X$y)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
    
    # Normal Density, rho = 0.5:
    x = (-40:40)/10
    X = grid2d(x)
    z = dnorm2d(X$x, X$y, rho = 0.5)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
 
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.cauchy2d =
    function()
{
    #  pcauchy2d - Computes bivariate Cauchy probability function
    #  dcauchy2d - Computes bivariate Cauchy density function
    #  rcauchy2d - Generates bivariate Cauchy random deviates
    
    # Cauchy Density:
    x = (-40:40)/10
    X = grid2d(x)
    z = dcauchy2d(X$x, X$y)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
    
    # Cauchy Density, rho = 0.5:
    x = (-40:40)/10
    X = grid2d(x)
    z = dcauchy2d(X$x, X$y, rho = 0.5)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
 
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.t2d =
    function()
{
    #  pt2d - Computes bivariate Student-t probability function
    #  dt2d - Computes bivariate Student-t density function
    #  rt2d - Generates bivariate Student-t random deviates
    
    # Student Density:
    x = (-40:40)/10
    X = grid2d(x)
    z = dt2d(X$x, X$y, nu = 4)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
    
    # Student Density, rho = 0.5:
    x = (-40:40)/10
    X = grid2d(x)
    z = dt2d(X$x, X$y, rho = 0.5, nu = 4)
    Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
    .perspPlot(Z)
    .contourPlot(Z)
 
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.delliptical2d =
    function()
{ 
    # Settings:
    xy = grid2d((-50:50)/10)
    
    # Contour Plots:
    par(mfrow = c(1, 1))
    contour(delliptical2d(xy, rho = 0.75, param = NULL, 
        type = "norm", output = "list"), main = "norm")
    contour(delliptical2d(xy, rho = 0.75, param = NULL, 
        type = "cauchy", output = "list"), main = "cauchy")
    contour(delliptical2d(xy, rho = 0.75, param = 4, 
        type = "t", output = "list"), main = "t")
    contour(delliptical2d(xy, rho = 0.75, param = NULL, 
        type = "laplace", output = "list"), main = "laplace")
    contour(delliptical2d(xy, rho = 0.75, param = NULL, 
        type = "kotz", output = "list"), main = "kotz")
    contour(delliptical2d(xy, rho = 0.75, param = NULL, 
        type = "epower", output = "list"), main = "epower")
        
    # Return Value:
    return()    
}


################################################################################
    

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA


################################################################################
# FUNCTION:           DESCRIPTION:
#  gridData            Generates a grid data set
#  persp.gridData      Generates a perspective plot from a grid data object
#  contour.gridData    Generates a contour plot from a grid data object
# REQUIREMENT:        DESCRIPTION:
#  akima               Package
#  spatial             Package
################################################################################


test.gridData = 
    function()
{
    #  gridData            Generates a grid data set
    #  persp.gridData      Generates a perspective plot from a grid data object
    #  contour.gridData    Generates a contour plot from a grid data object
     
    # Generate Grid Data:
    gD <- gridData()
    
    # Perspective Plot:
    persp(gD)
    
    # Contour Plot:
    contour(gD) 
    
    # Return Value:
    return()    
}


# ------------------------------------------------------------------------------


test.gridDataPlot = 
    function()
{   
    #  gridData            Generates a grid data set
    #  persp.gridData      Generates a perspective plot from a grid data object
    #  contour.gridData    Generates a contour plot from a grid data object
      
    # Generate Akima interpolated Grid Data:
    require(akima)
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    x = runif(999)-0.5
    y = runif(999)-0.5
    z = cos(2*pi*(x^2+y^2))
    ans = akimaInterp(x, y, z, extrap = FALSE)
    persp(ans)
    title(main = "Akima Interpolation") 
    contour(ans)
    title(main = "Akima Interpolation") 
    
    # Generate Kriged Grid Data:
    require(spatial)
    RNGkind(kind = "Marsaglia-Multicarry", normal.kind = "Inversion")
    set.seed(4711, kind = "Marsaglia-Multicarry")
    x = runif(999)-0.5
    y = runif(999)-0.5
    z = cos(2*pi*(x^2+y^2))
    ans = krigeInterp(x, y, z, extrap = FALSE)
    persp(ans)
    title(main = "Kriging") 
    contour(ans)
    title(main = "Kriging") 
    
    # Return Value:
    return()    
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             BIVARIATE CAUCHY DISTRIBUTION:
#  pcauchy2d             Computes bivariate Cauchy probability function
#  dcauchy2d             Computes bivariate Cauchy density function
#  rcauchy2d             Generates bivariate Cauchy random deviates
################################################################################


pcauchy2d <- 
    function(x, y = x, rho = 0)
{   
    # A function Implemented by Diethelm Wuertz

    # Description:
    #   Computes bivariate Cauchy probability function

    # Arguments:
    #   x, y - two numeric values or vectors of the same length at
    #       which the probability will be computed.

    # Example:
    #   pt2d(rnorm(5), rnorm(5), 0.5, 5)

    # Value:
    #   returns a numeric vector of probabilities of the same length
    #   as the input vectors

    # FUNCTION:

    # Settings:
    # Probaility:
    ans <- pt2d(x = x, y = y, rho = rho, nu = 1)
    attr(ans, "control") = c(rho = rho)

    # Return Value:
    ans
}


# ------------------------------------------------------------------------------


dcauchy2d <- 
    function(x, y = x, rho = 0)
{   
    # A function implemented by Diethelm Wuertz

    # Arguments:
    #   n - number of random deviates to be generated
    #   rho - the linear correlation, a numeric value between
    #       minus one and one.

    # Description:
    #   Computes bivariate Cauchy density function

    # Note:
    #   Partly copied from contributed R package 'sn'

    # FUNCTION:

    # Density:
    density <- dt2d(x = x, y = y, rho = rho, nu = 1)
    attr(density, "control") <- c(rho = rho)

    # Return value:
    density
}


# ------------------------------------------------------------------------------


rcauchy2d =
    function(n, rho = 0)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Generates bivariate Cauchy random deviates

    # Arguments:
    #   n - number of random deviates to be generated
    #   rho - the linear correlation, a numeric value between
    #       minus one and one.

    # Note:
    #   Partly copied from contributed R package 'mvtnorm'
    #   Author Friedrich Leisch

    # FUNCTION:

    # Random Deviates:
    ans <- rt2d(n = n, rho = rho, nu = 1)
    attr(ans, "control") <- c(rho = rho)

    # Return Value:
    ans
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             BIVARIATE STUDENT-T DISTRIBUTION:
#  pt2d                  Computes bivariate Student-t probability function
#  dt2d                  Computes bivariate Student-t density function
#  rt2d                  Generates bivariate Student-t random deviates
# REQUIRES:
#  mvtnorm
################################################################################


pt2d <-  
    function(x, y = x, rho = 0, nu = 4) 
{   
    # pt2d: Uses pmvt from R package "sn"

    # Description:
    #   Computes bivariate Student-t probability function
    
    # Arguments:
    #   x, y - two numeric values or vectors of the same length at
    #       which the probability will be computed. 
    
    # Example:
    #   pt2d(rnorm(5), rnorm(5), 0.5, 5)
    
    # Value:
    #   returns a numeric vector of probabilities of the same length
    #   as the input vectors
   
    # FUNCTION:
    
    # Normal Limit:
    if (nu == Inf) return(pnorm2d(x = x, y = y, rho = rho)) 
    
    # Settings:
    sigma <- diag(2) 
    sigma[1, 2] <- sigma[2, 1] <- rho 
    X <- cbind(x, y)
    
    # Probaility:
    # ans  <- pmvt(X, dim = 2, mu = c(0, 0), Omega = sigma, 
    # alpha = c(0, 0), df = nu) 
    .pmvt <- function(x, delta, sigma, df)
       mvtnorm::pmvt(
         lower = -Inf, upper = x, delta = delta, sigma = sigma, df = df)        
    ans <-  apply(X, 1, ".pmvt", delta = c(0,0), sigma = sigma, df = nu)
    attr(ans, "control") <- c(rho = rho, nu = nu)
    
    # Return Value:
    ans
}
    
    

# -----------------------------------------------------------------------------


dt2d <-  
    function(x, y = x, rho = 0, nu = 4)
{   
    # A function implemented by Diethelm Wuertz

    # Arguments:
    #   n - number of random deviates to be generated
    #   rho - the linear correlation, a numeric value between 
    #       minus one and one.
    
    # Description:
    #   Computes bivariate Student-t density function
    
    # Example:
    #   dt2d(rnorm(5), rnorm(5), 0.5, 5)
    
    # Note:
    #   Partly copied from contributed R package 'sn'
    
    # FUNCTION:
    
    # Normal Limit:
    if (nu == Inf) return(dnorm2d(x = x, y = y, rho = rho)) 
    
    # Argument:
    xoy <- (x^2 - 2*rho*x*y + y^2)/ (2*(1 - rho^2))
    
    # Density:
    density <- (1 + 2*xoy/nu)^(-(nu+2)/2) / (2*pi*sqrt(1-rho^2))
    attr(density, "control") <- c(rho = rho, nu = nu)
    
    # Return value:
    density
}


# -----------------------------------------------------------------------------


rt2d <-
    function(n, rho = 0, nu = 4) 
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Generates bivariate Student-t random deviates
    
    # Arguments:
    #   n - number of random deviates to be generated
    #   rho - the linear correlation, a numeric value between 
    #       minus one and one.
    
    # Note:
    #   Partly copied from contributed R package 'mvtnorm'
    #   Author Friedrich Leisch
    
    # FUNCTION:
    
    # Normal Limit:
    if (nu == Inf) return(rnorm2d(n = n, rho = rho)) 
    
    # Random Deviates:
    ans <- rnorm2d(n, rho)/sqrt(rchisq(n, nu)/nu)
    attr(ans, "control") <- c(rho = rho, nu = nu)
    
    # Return Value:
    ans
}


###############################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:           DESCRIPTION:
#  dmsn                Multivariate Skew Normal Density function
#  pmsn                Multivariate Skew Normal Probability function
#  rmsn                Multivariate Skew Normal Random Number generator
# REQUIRES:           DESCRIPTION:
#  sn                  Contributed R-Package
#  fDISTSFIT           fBasics Package
###############################################################################


# NOTE:
#   The former multivariate skew Normal distribution functions have 
#   been deprecated. Use instead the functions directly from contributed
#   Package "sn".


# NOTE:
#   The former multivariate "mvFit" parameter estimation functions have
#   been deprecated. New easy to use fitting functions have been adde:
#   ms[cdt]Fit have been added.


msnFit <- 
  function(x, trace=FALSE, title=NULL, description=NULL)
{
  fit <- sn::msn.mle(x = rep(1, nrow(x)), y = x, start=NULL, trace=trace)
  fit$estimated <- fit$dp
  
  if (is.null(title)) 
    title <- "Skew Normal Parameter Estimation"
  
  if (is.null(description)) 
    description <- description() 
  
  new("fDISTFIT", 
      call = match.call(), 
      model = "Skew Normal Distribution", 
      data = as.data.frame(x), 
      fit = fit, 
      title = title, 
      description = description)
}


###############################################################################


.mnFit <- 
  function(x, trace = FALSE, title = NULL, description = NULL)
  {
    fit <- list()
    fit$dp <- NA
    fit$logL <- NA
    fit$aux <- NA
    fit$opt.method <- NA
    fit$estimated <- list(
      beta = colMeans(x),
      Omega = cov(x),
      alpha = rep(0, times = ncol(x)),
      nu = Inf)
    
    if (is.null(title)) 
      title <- "Normal Parameter Estimation"
    
    if (is.null(description)) 
      description <- description()
    
    new("fDISTFIT", 
        call = match.call(), 
        model = "Skew Normal Distribution", 
        data = as.data.frame(x), 
        fit = fit, 
        title = title, 
        description = description)
  }


###############################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  dmvsnorm
#  pmvsnorm
#  rmvsnorm
# FUNCTION:             DESCRIPTION:
#  dmvst
#  pmvst
#  rmvst
################################################################################


################################################################################
# Obsolete Functions:
#
#  dmvsnorm(x, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim))
#  pmvsnorm(q, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim))
#  rmvsnorm(n, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim))
#  
#  dmvst(x, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim), df=4)
#  pmvst(q, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim), df=4)
#  rmvst(n, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim), df=4)


# -----------------------------------------------------------------------------


dmvsnorm <- 
  function(x, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim))
    sn::dmsn(x=x, xi=mu, Omega=Omega, alpha=alpha)

pmvsnorm <- 
  function(q, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim))
    sn::pmsn(x=q, xi=mu, Omega=Omega, alpha=alpha)

rmvsnorm <- 
  function(n, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim))
    sn::rmsn(n=n, xi=mu, Omega=Omega, alpha=alpha)


# -----------------------------------------------------------------------------


dmvst <- 
  function(x, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim), df=4)
    sn::dmst(x=x, xi=mu, Omega=Omega, alpha=alpha, nu=df)

pmvst <- 
  function(q, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim), df=4)
    sn::pmst(x=q, xi=mu, Omega=Omega, alpha=alpha, nu=df)

rmvst <- 
  function(n, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim), df=4)
    sn::rmst(n=n, xi=mu, Omega=Omega, alpha=alpha, nu=df)


###############################################################################


mvFit <- 
  function(x, method = c("snorm", "st"), fixed.df = NA, 
           title = NULL, description = NULL, trace = FALSE)
{   
  method <- match.arg(method)

  if (method == "snorm") {
    ans <- msnFit(x, trace=trace)
  }
      
  if (method == "st") {
    if (is.na(fixed.df)) fixed.nu <- NULL else fixed.nu <- fixed.df
    ans <- mstFit(x, fixed.nu=fixed.nu, trace=trace)
  }

  # Return Value:
  ans

}


###############################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:           DESCRIPTION:
#  dmst                Multivariate Skew Student-t Density function
#  pmst                Multivariate Skew Student-t Probability function
#  rmst                Multivariate Skew Student-t Random Number generator
# REQUIRES:           DESCRIPTION:
#  sn                  Contributed R-Package
#  fDISTSFIT           fBasics Package
################################################################################


# NOTE:
#   The former multivariate skew Student-t distribution functions have 
#   been deprecated. Use instead the functions directly from contributed
#   Package "sn".


# NOTE:
#   The former multivariate "mvFit" parameter estimation functions have
#   been deprecated. New easy to use fitting functions have been adde:
#   ms[cdt]Fit have been added.


mstFit <- 
  function(x, fixed.nu=NULL, trace=FALSE, title=NULL, description=NULL)
{
  # Fit distributional Parameters:
  if (is.null(fixed.nu)) {
    fit <- sn::mst.mple(
      x = rep(1, nrow(x)), y = x, start=NULL, fixed.nu=NULL, 
      trace=trace, penalty=NULL)
    fit$estimated <- fit$dp
  } else {
    fit <- sn::mst.mple(
      x = rep(1, nrow(x)), y = x, start=NULL, fixed.nu=fixed.nu, 
      trace=trace, penalty=NULL)
    fit$estimated <- list(fit$dp, nu=fixed.nu)
  }
  
  # Add Title and Description:
  if (is.null(title)) 
    title <- "Student-t Parameter Estimation"
  
  if (is.null(description)) 
    description <- description()
  
  # Return Value:
  new("fDISTFIT", 
      call = match.call(), 
      model = "Skew Student-t Distribution", 
      data = as.data.frame(x), 
      fit = fit, 
      title = title, 
      description = description)
}


###############################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  adapt                 Integrates over a two dimensional unit square
################################################################################


adapt <-
  function(ndim=NULL, lower, upper, functn, ...)
{
  ans <- cubature::adaptIntegrate(
    f=functn, lowerLimit=lower, upperLimit=upper, ...)
  
  # Return Value
  ans
}


# -----------------------------------------------------------------------------
# replaced by the cubature adaptIntegrate package
# you will find the code in the deprecated folder


# adapt <- function (ndim, lower, upper, minpts = 100, maxpts = NULL, 
#                   functn, eps = 0.01, ...)


# Title: adapt -- multidimensional numerical integration
# Package: adapt
# Version: 1.0-4
# Author: FORTRAN by Alan Genz, 
#     S by Mike Meyer, R by Thomas Lumley and Martin Maechler
# Description: Adaptive Quadrature in up to 20 dimensions
# Depends:
# License: Unclear (Fortran) -- code in Statlib's ./S/adapt
# Maintainer: Thomas Lumley <tlumley@u.washington.edu>
# Packaged: Fri Apr 20 11:38:07 2007; thomas


# [from Statlib's original  http://lib.stat.cmu.edu/S/adapt ]
# This code contains an S function and supporting C and Fortran code for
# adaptive quadrature.  The underlyling fortran code is purported to
# work in from 2 to 20 dimensions.  The code is set up to dynamically
# load from a central library area.  If you can not do dynamic loading,
# you may need to build a staticly loaded version.  The adapt S function
# calls load.if.needed to do the dynamic loading.  You will have to
# change the functions used here (probably to call library.dynam).
# S code written by Michael Meyer (mikem@andrew.cmu.edu).
# October, 1989.


# 2002-03-14  Martin Maechler  <maechler@stat.math.ethz.ch>
# * DESCRIPTION (Version): 1.0-3 --> CRAN
# * R/adapt.R (adapt): use defaults for minpts, maxpts, eps;
#   more logical maxpts default (for ndim >= 7) using rulcls
# * man/adapt.Rd: extended example
# 2002-03-13  Martin Maechler  <maechler@stat.math.ethz.ch>
# * DESCRIPTION (Version): 1.0-2
# * man/adapt.Rd: indentation, using \code{.}, etc;
#   example also tries p=5 dimensions
# * R/adapt.R: clean up (spaces)
# 2002-01-09  Martin Maechler  <maechler@stat.math.ethz.ch>
# * R/adapt.R: do not use .Alias anymore
# 2001-06-29  Thomas Lumley <tlumley@u.washington.edu>
# * move (improved!) integrate() into base, using .Call() etc.


# Message-ID: <4AD7A74B.3020108@math.wsu.edu>
# Date: Thu, 15 Oct 2009 15:50:51 -0700
# From: Alan Genz <genz@math.wsu.edu>
# User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.21) 
#     Gecko/20090402 SeaMonkey/1.1.16
# MIME-Version: 1.0
# To: Diethelm Wuertz <wuertz@itp.phys.ethz.ch>
# CC: Alan C Genz <alangenz@wsu.edu>
# Subject: Re: adapt
# References: <4AD3032B.4090801@itp.phys.ethz.ch>
# In-Reply-To: <4AD3032B.4090801@itp.phys.ethz.ch>
# Content-Type: text/plain; charset=ISO-8859-1; format=flowed
# Content-Transfer-Encoding: 7bit
# Status:  O
# Dear Prof. Wuertz,
# Thank you for your message and your interest in my adaptive integration
# Fortran code. I would be pleased if you included my code in your open
# source R package under the Gnu GPL2 license. You have my permission to 
# do this.
# Sincerely,
# Alan Genz


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  delliptical2d         Computes density for elliptical distributions
# FUNCTION:             DESCRIPTION:
#  .gfunc2d              Generator Function for elliptical distributions
#  .delliptical2dSlider  Slider for bivariate densities
################################################################################


delliptical2d <- 
    function(x, y = x, rho = 0, param = NULL, type = c("norm", "cauchy", "t", 
    "logistic", "laplace", "kotz", "epower"), output = c("vector", "list"))
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Density function for bivariate elliptical distributions
    
    # Arguments:
    #   x, y -  two numeric vectors of the same length.
    #   rho -  a anumeric value specifying the correlation.
    #   param - NULL, a numeric value, or a numeric vector adding
    #       additional parameters to the generator function.
    #   type -  a character string denoting the type of distribution.
    #       This may be either 
    #       "norm" for the normal distribution, or
    #       "cauchy" for the Cauchy distribution, or
    #       "t" for the Student-t distribution, or
    #       "logistic" for the logistic distribution, or
    #       "laplace" for the distribution, or
    #       "kotz" for the original Kotz distribution, or 
    #       "epower" for the exponential power distribution
        
    # FUNCTION:
    
    # Type:
    type <- match.arg(type)
    
    # Settings:
    if (is.list(x)) {
        y <- x$y
        x <- x$x
    }
    if (is.matrix(x)) {
        y <- x[, 2]
        x <- x[, 2]
    }

    # Add Default Parameters:
    if (is.null(param)) {
        if (type == "t") param = c(nu = 4)
        if (type == "kotz") param = c(r = sqrt(2))
        if (type == "epower") param = c(r = sqrt(2), s = 1/2)
    }
    
    # Density:
    xoy <- ( x^2 - 2*rho*x*y + y^2 ) / (1-rho^2)
    lambda <- .gfunc2d(param = param, type = type)[[1]]
    density <- lambda * .gfunc2d(x = xoy, param = param, type = type) /
        sqrt(1 - rho^2)
    
    # Add attributes:
    if (is.null(param)) {
        attr(density, "control") = unlist(list(type = type, rho = rho))
    } else {
        attr(density, "control") = unlist(list(type = type, rho = rho, 
            param = param))
    }
    
    # As List ?
    if (output[1] == "list") {
        N = sqrt(length(x))
        x = x[1:N]
        y = matrix(y, ncol = N)[1, ]
        density = list(x = x, y = y,  z = matrix(density, ncol = N))
    }
    
    # Return Value:
    density
}


# ------------------------------------------------------------------------------


.gfunc2d = 
    function(x, param = NULL, type = c("norm", "cauchy", "t", "logistic", 
    "laplace", "kotz", "epower"))
{   
    # A function implemented by Diethelm Wuertz
    
    # Description:
    #   Generator function for elliptical distributions
    
    # Note:
    #   A copy from fExtremes 'gfunc'
    
    # Arguments:
    #   x -  a numeric vector
    #   param - NULL, a numeric value, or a numeric vector adding.
    #       additional parameters to the generator function.
    #   type -  a character string denoting the type of distribution.
    #       This may be either 
    #       "norm" for the normal distribution, or
    #       "cauchy" for the Cauchy distribution, or
    #       "t" for the Student-t distribution, or
    #       "logistic" for the logistic distribution, or
    #       "laplace" for the distribution, or
    #       "kotz" for the original Kotz distribution, or 
    #       "epower" for the exponential power distribution
    
    # Value:
    #   Returns a numeric vector "g(x)" for the generator computed at
    #   the x values taken from the input vector. If x is missing,
    #   the normalizing constant "lambda" will be returned.
    
    # FUNCTION:
    
    # Handle Missing x:
    if (missing(x)) {
        x = NA
        output = "lambda"
    } else {
        output = "g"
    }
    
    # Get Type:
    type = type[1]
    
    # Get Parameters:   
    # if (is.null(param)) param = .ellipticalParam$param
    
    # Create Generator:
    if (type == "norm") {
        g = exp(-x/2)
        lambda = 1 / (2*pi)
        param = NULL
    }
    if (type == "cauchy") {
        g = ( 1 + x )^ (-3/2 )
        lambda = 1 / (2*pi)
        param = NULL
    }
    if (type == "t") {
        if (is.null(param)) {
            nu = 4
        } else {
            nu = param[[1]]
        }
        g = ( 1 + x/nu )^ ( -(nu+2)/2 )
        lambda = 1/(2*pi)
        param = c(nu = nu)
    }
    if (type == "logistic"){
        g = exp(-x/2)/(1+exp(-x/2))^2
        # lambda:
        # integrate(function(x) { exp(-x)/(1+exp(-x))^2}, 0, Inf, 
        #   subdivision = 10000, rel.tol = .Machine$double.eps^0.8)
        # 0.5 with absolute error < 2.0e-13
        lambda = 1 / pi 
        param = NULL
    }
    if (type == "laplace") { # or "double exponential"
        # epower:
        r = sqrt(2)
        s = 1/2
        g = exp(-r*(x/2)^s)
        lambda = s * r^(1/s) / ( 2 * pi * gamma(1/s) )
        param = NULL
    }
    if (type == "kotz") {
        # epower: s = 1
        if (is.null(param)) {
            r = sqrt(2)
        } else {
            r = param
        }
        g = exp(-r*(x/2))
        lambda = r/(2*pi)
        param = c(r = r)
    }
    if (type == "epower") {
        if (is.null(param)) {
            r = sqrt(2) 
            s = 1/2
        } else {
            r = param[[1]]
            s = param[[2]]
        }
        g = exp(-r*(x/2)^s)
        lambda = s * r^(1/s) / ( 2 * pi * gamma(1/s) )
        param = c(r = r, s = s)
    }
    
    # Output:
    output = output[1]
    if (output == "g") {
        ans = g
    } else if (output == "lambda") {
        ans = lambda
    }
    
    # Add Control:
    if (output == "g") {
        attr(ans, "control") = c(type = type, lambda = as.character(lambda))
    } else if (output == "lambda") {
        if (is.null(param)) {
            attr(ans, "control") = unlist(list(type = type))
        } else {
            attr(ans, "control") = unlist(list(type = type, param = param))
        }
    }
    
    # Return Value:
    ans
}


# ------------------------------------------------------------------------------


.delliptical2dSlider <-
    function(B = 10, eps = 1.e-3)
{   
    # A function implemented by Diethelm Wuertz
        
    # Description:
    #   Displays interactively perspective plots of density
    
    #FUNCTION:
    
    # Graphic Frame:
    par(mfrow = c(1, 1), cex = 0.7)
    
    # Internal Function:
    refresh.code = function(...)
    {
        # Sliders:
        Distribution = .sliderMenu(no = 1)
        N = .sliderMenu(no = 2)
        rho = .sliderMenu(no = 3)
        nu = .sliderMenu(no = 4)
        r = .sliderMenu(no = 5)
        s = .sliderMenu(no = 6)
        nlev = .sliderMenu(no = 7)
        ncol = .sliderMenu(no = 8)
        if (rho == +1) rho = rho - eps
        if (rho == -1) rho = rho + eps
        
        # Title:
        Names = c("- Normal", "- Cauchy", "- Student t", "- Logistic",
            "- Laplace", "- Kotz", "- Exponential Power")      
        Title = paste("Elliptical Density No:", as.character(Distribution), 
            Names[Distribution], "\nrho = ", as.character(rho)) 
        if (Distribution == 3) Title = paste(Title, "nu =", as.character(nu))
        if (Distribution >= 6) Title = paste(Title, "r =", as.character(r))
        if (Distribution >= 7) Title = paste(Title, "s =", as.character(s))
        
        # Plot: 
        xy= grid2d(x = seq(-5, 5, length = N))
        Type = c("norm", "cauchy", "t", "logistic", "laplace", "kotz", "epower")
        param = NULL
        if (Distribution == 3) param = nu
        if (Distribution == 6) param = r
        if (Distribution == 7) param = c(r, s)
        D = delliptical2d(x = xy, rho = rho, param = param, 
            type = Type[Distribution], output = "list")
        image(D, col = heat.colors(ncol), xlab = "x", ylab = "y" )
        contour(D, nlevels = nlev, add = TRUE)
        title(main = Title)
        
        # Reset Frame:
        par(mfrow = c(1, 1), cex = 0.7)
    }
  
    # Open Slider Menu:
    plot.names = c("Plot - levels", "... colors")
    .sliderMenu(refresh.code,
        names = c("Distribution", "N", "rho", "t: nu", "r", "s", plot.names),
        minima      = c(       1,  10,    -1,       1,   0,   0,   10,   12),
        maxima      = c(       7, 100,    +1,       B,   B,   B,  100,  256),
        resolutions = c(       1,  10,   0.1,     0.1, 0.1, 0.1,   10,    1),
        starts      = c(       1,  10,     0,       4,   1,   1,   10,   12)) 
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:           DESCRIPTION:
#  dmsc                Multivariate Skew Cauchy Density function
#  pmsc                Multivariate Skew Cauchy Probability function
#  rmsc                Multivariate Skew Cauchy Random Number generator
# REQUIRES:           DESCRIPTION:
#  sn                  Contributed R-Package
#  fDISTSFIT           fBasics Package
###############################################################################


# NOTE:
#   The former multivariate skew Cauchy distribution functions have 
#   been deprecated. Use instead the functions directly from contributed
#   Package "sn".


# NOTE:
#   The former multivariate "mvFit" parameter estimation functions have
#   been deprecated. New easy to use fitting functions have been adde:
#   ms[cdt]Fit have been added.


mscFit <- 
  function(x, trace=FALSE, title=NULL, description=NULL)
{
  fit <- sn::mst.mple(
    x = rep(1, nrow(x)), y = x, start=NULL, fixed.nu=1, 
    trace=trace, penalty=NULL)
  fit$estimated <- fit$dp
  
  if (is.null(title)) 
    title <- "Skew Cauchy Parameter Estimation"
  
  if (is.null(description)) 
    description <- description()
  
  new("fDISTFIT", 
      call = match.call(), 
      model = "Skew Cauchy Distribution", 
      data = as.data.frame(x), 
      fit = fit, 
      title = title, 
      description = description)
}


###############################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  grid2d                Returns from two vectors x-y grid coordinates
################################################################################


grid2d <- 
    function(x = (0:10)/10, y = x)
{   
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Creates from two vectors x-y grid coordinates
    
    # Arguments:
    #   x, y - two numeric vectors defining the x and y coordinates.
    
    # Value:
    #   returns a list with two vectors named $x and $y spanning the 
    #   grid defined by the coordinates x and y.
    
    # Example:
    #   > grid2d(1:3, 1:2)
    #       $x
    #       [1] 1 2 3 1 2 3
    #       $y
    #       [1] 1 1 1 2 2 2

    # FUNCTION: 
    
    # Prepare for Input:
    nx  = length(x)
    ny  = length(y)
    xoy = cbind(rep(x, ny), as.vector(matrix(y, nx, ny, byrow = TRUE)))
    XY  = matrix(xoy, nx * ny, 2, byrow = FALSE)
    
    # Return Value:
    list(x = XY[, 1], y = XY[, 2])
}



################################################################################

\name{norm2d}

\alias{norm2d}

\alias{pnorm2d}
\alias{dnorm2d}
\alias{rnorm2d}


\title{Bivariate Normal Distribution}


\description{
    
    Density, distribution function, and random 
    generation for the bivariate normal
    distribution.
}


\usage{
pnorm2d(x, y = x, rho = 0)
dnorm2d(x, y = x, rho = 0)
rnorm2d(n, rho = 0)
}


\arguments{

     \item{n}{
        the number of random deviates to be generated, an integer value.
        }
    \item{rho}{
        the correlation parameter, a numeric value ranging between 
        minus one and one, by default zero.     
        }
    \item{x, y}{
        two numeric vectors defining the x and y coordinates. 
        }    
        
}


\value{

    \code{pnorm2d}
    \cr
    returns a two column matrix of probabilities for the bivariate 
    normal distribution function.\cr
    
    \code{dnorm2d}
    \cr
    returns a two column matrix of densities for the bivariate 
    normal distribution function.\cr 
    
    \code{rnorm2d}
    \cr
    returns a two column matrix of random deviates generated from
    the bivariate normal distribution function.
    
}


\references{
    
Azzalini A., (2004);
    \emph{The sn Package};
    R Reference Guide available from www.r-project.org.
    
Venables W.N., Ripley B.D., (2002); 
    \emph{Modern Applied Statistics with S},
    Fourth Edition, Springer.
            
}


\author{

    Adelchi Azzalini for the underlying pnorm2d function, \cr
    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## Bivariate Normal Density:
   x = (-40:40)/10
   X = grid2d(x)
   z = dnorm2d(X$x, X$y, rho = 0.5)
   Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
   persp(Z, theta = -40, phi = 30, col = "steelblue")
}


\keyword{math}

\name{utils-gridding2d}

\alias{utils-gridding2}


\alias{gridData}
\alias{persp.gridData}
\alias{contour.gridData}


\title{Bivariate Gridded Data Sets}


\description{
    
    Functions which allow to generate bivariate gridded data sets.
    \cr

    Grid Data Functions:
    
    \tabular{ll}{
    \code{gridData} \tab generates a grid data set of class 'gridData', \cr
    \code{persp} \tab generates a perspective plot from a grid data set, \cr
    \code{contour} \tab generates a contour plot from a grid data set.}
    
}
    

\usage{ 
gridData(x = (-10:10)/10, y = x, z = outer(x, y, function(x, y) (x^2+y^2) ) )

\method{persp}{gridData}(x, theta = -40, phi = 30, col = "steelblue", 
    ticktype = "detailed", \dots)
\method{contour}{gridData}(x, addImage = TRUE, \dots)
}


\arguments{
  
    \item{addImage}{
        [contour] - \cr
        a logical flag indicating if an image plot should be underlayed
        to the contour level plot.
        }
    \item{x, y, z}{
        [gridData] - \cr
        \code{x} and \code{y} are two numeric vectors of grid pounts
        and \code{z} is a numeric matrix or any other rectangular object 
        which can be transformed by the function \code{as.matrix} into 
        a matrix object.
        }
    \item{theta, phi, col, ticktype}{
        [persp] - \cr
        tailored parameters passed the perspective plot function \code{persp}.
        }
    \item{\dots}{
        [contour][persp] - \cr
        additional arguments to be passed to the perspectice and countour
        plot functions.
        }
    
}

 
\value{
    
    \code{gridData} - \cr
    A list with at least three entries, \code{x}, \code{y} and \code{z}. 
    
    The returned values, can be directly used by the \code{persp.gridData()} 
    and \code{contour.gridData} 3D plotting methods.
    
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port,\cr
    H. Akima for the Fortran Code of the Akima spline interpolation routine.\cr
    
}


\examples{
## gridData -
   # Grid Data Set:
   gD = gridData()
   persp(gD)
   contour(gD)
}


\keyword{programming}

\name{utils-adapt}

\alias{adapt}


\title{Integrator for multivariate distributions}


\description{
    
    The function is for adaptive quadrature. The underlyling 
    fortran code is purported to work in from 2 to 20 dimensions.   

}


\usage{
adapt(ndim, lower, upper, minpts = 100, maxpts = NULL, functn, 
    eps = 0.01, \dots)
}


\details{

    The function computes computes an n-dimensional integral between
    lower and upper bounds. Infinite rectangles are not allowed, and 
    the number of dimensionas must be between 2 and 20.

    The function is modified from Mike Meyer's S code. The functions 
    just calls A.C. Genz's fortran ADAPT subroutine to do all of the 
    calculations. A work array is allocated within the C/Fortran code.

    The Fortran function has been modified to use double precision, 
    for compatibility with R. It only works in two or more dimensions; 
    for one-dimensional integrals use the \code{integrate} function 
    in the base package.

    Setting \code{maxpts} to NULL asks the function to keep doubling 
    \code{maxpts} (starting at \code{max(minpts,500, r(ndim))}) until 
    the desired precision is achieved or R runs out of memory. Note 
    that the necessary number of evaluations typically grows 
    exponentially with the dimension \code{ndim}, and the underlying 
    code requires \code{maxpts >= r(ndim)} where \code{r(d) = 2^d + 
    2 d(d + 3) + 1}.
  
}


\arguments{

    \item{ndim}{   
        the dimension of the integral.
        }
    \item{lower}{
        vector of at least length \code{ndim} of the lower bounds 
        on the integral.
        }
    \item{upper}{	
        vector of at least length \code{ndim} of the upper bounds 
        on the integral.
        }
    \item{minpts}{
        the minimum number of function evaluations.
        }
    \item{maxpts}{	
        the maximum number of function evaluations or NULL per 
        default, see Details.
        }
    \item{functn}{	
        an R function which should take a single vector argument and 
        possibly some parameters and return the function value at 
        that point. \code{functn} must return a single numeric value.
        }
    \item{eps}{	
        the desired accuracy for the relative error.
        }
    \item{\dots}{	
        other parameters to be passed to \code{functn}.
        }
        
}


\value{
    
    A list of \code{class} \code{"integration"} with components

    \item{value}{  
        the estimated integral.
        }
    \item{relerr}{ 	
        the estimated relative error; < \code{eps} argument if the 
        algorithm converged properly.
        }
    \item{minpts}{
        the actual number of function evaluations.
        }

    \item{ifail}{
        an error indicator. If \code{ifail} is not equal to 0, the function 
        warns the user of the error condition.
        }
    
}


%\references{}


%\author{}


\examples{
## Example of  p - dimensional spherical normal distribution:
   ir2pi <- 1/sqrt(2*pi)
   fred <- function(z) { ir2pi^length(z) * exp(-0.5 * sum(z * z))}

   adapt(2, lo = c(-5, -5), up = c(5, 5), functn = fred)
   adapt(2, lo = c(-5, -5), up = c(5, 5), functn = fred, eps = 1e-4)
   adapt(2, lo = c(-5, -5), up = c(5, 5), functn = fred, eps = 1e-6)

## adapt "sees" function ~= constantly 0 --> wrong result
   adapt(2, lo = c(-9,-9), up = c(9,9), functn = fred)
   
## fix by using much finer initial grid:
   adapt(2, lo = c(-9,-9), up = c(9,9), functn = fred, min = 1000)
   adapt(2, lo = c(-9,-9), up = c(9,9), functn = fred, min = 1000, eps = 1e-6)
   i1 <- print(integrate(dnorm, -2, 2))$value   

## True values for the following example:
   i1 ^ c(3, 5)
   for(p in c(3, 5)) {
     cat("\np = ", p, "\n------\n")
     f.lo <- rep(-2., p)
     f.up <- rep(+2., p)
     # not enough evaluations:
     print(adapt(p, lo=f.lo, up=f.up, max=100*p, functn = fred))
     # enough evaluations:
     print(adapt(p, lo=f.lo, up=f.up, max=10^p,  functn = fred))
     # no upper limit; p=3: 7465 points, ie 5 attempts (on an Athlon/gcc/g77):
     print(adapt(p, lo=f.lo, up=f.up, functn = fred, eps = 1e-5))
   }
}


\keyword{math}

\name{bvdist-elliptical2d}


\alias{elliptical2d}
\alias{delliptical2d}


\title{Bivariate Elliptical Densities}


\description{
    
    Density function for bivariate elliptical 
    distributions. 
}


\usage{
delliptical2d(x, y, rho = 0, param = NULL, type = c("norm", "cauchy", "t", 
    "logistic", "laplace", "kotz", "epower"), output = c("vector", "list"))
}


\arguments{

    \item{x, y}{
        two numeric vectors defining the x and y coordinates. \cr
        }       
    \item{output}{
        output - a character string specifying how the output should be 
        formatted. By default a vector of the same length as \code{u} 
        and \code{v}. If specified as \code{"list"} then \code{u} and 
        \code{v} are expected to span a two-dimensional grid as outputted 
        by the function \code{grid2d} and the function returns a list with
        elements \code{$x}, \code{y}, and \code{z} which can be directly 
        used for example by 2D plotting functions.
        }
    \item{param}{
        additional parameters to specify the bivariate density function.
        Only effective for the Kotz and Exponential Power distribution.
        For the Kotz distribution we can specify a numeric value, by default
        defined as \code{param=c(r=sqrt(2))}, and for the Exponential
        Power distribution a numeric vector, by default defined as
        \code{param=c(r=sqrt(2)),s=1/2}.
        }
    \item{rho}{
        the correlation parameter, a numeric value ranging between 
        minus one and one, by default zero.     
        }
    \item{type}{
        the type of the elliptical copula. A character string selected 
        from: \code{"norm"}, \code{"cauchy"}, \code{"t"}, \code{"laplace"}, 
        \code{"kotz"}, or \code{"epower"}.
        }
}


\value{
 
    \code{delliptical2d}
    \cr
    returns a two column matrix of densities for the selected bivariate 
    elliptical distribution function.
    
}


\references{
    
Azzalini A., (2004);
    \emph{The sn Package};
    R Reference Guide available from www.r-project.org.
    
Venables W.N., Ripley B.D., (2002); 
    \emph{Modern Applied Statistics with S},
    Fourth Edition, Springer.
         
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## delliptical2d -
   # Kotz' Elliptical Density:
   x <- (-40:40)/10
   X <- grid2d(x)
   z <- delliptical2d(X$x, X$y, rho = 0.5, type = "kotz")
   Z <- list(x = x, y = x, z = matrix(z, ncol = length(x)))
   
## Perspective Plot:
   persp(Z, theta = -40, phi = 30, col = "steelblue")
   
## Image Plot with Contours:
   image(Z, main = "Bivariate Kotz")
   contour(Z, add=TRUE)
   
## Internal Density Slider:
   \dontrun{
   .delliptical2dSlider()
   }
}


\keyword{math}

\name{BivariateGridding}

\alias{BivariateGridding}


\alias{gridData}
\alias{persp.gridData}
\alias{contour.gridData}


\title{Bivariate Gridded Data Sets}


\description{
    
    A collection and description of functions which
    allow to generate bivariate gridded data sets.
    \cr

    Grid Data Functions:
    
    \tabular{ll}{
    \code{gridData} \tab generates a grid data set of class 'gridData', \cr
    \code{persp} \tab generates a perspective plot from a grid data set, \cr
    \code{contour} \tab generates a contour plot from a grid data set.}
    
}
    

\usage{ 
gridData(x = (-10:10)/10, y = x, z = outer(x, y, function(x, y) (x^2+y^2) ) )

\method{persp}{gridData}(x, theta = -40, phi = 30, col = "steelblue", 
    ticktype = "detailed", \dots)
\method{contour}{gridData}(x, addImage = TRUE, \dots)
}


\arguments{
  
    \item{addImage}{
        [contour] - \cr
        a logical flag indicating if an image plot should be underlayed
        to the contour level plot.
        }
    \item{x, y, z}{
        [gridData] - \cr
        \code{x} and \code{y} are two numeric vectors of grid pounts
        and \code{z} is a numeric matrix or any other rectangular object 
        which can be transformed by the function \code{as.matrix} into 
        a matrix object.
        }
    \item{theta, phi, col, ticktype}{
        [persp] - \cr
        tailored parameters passed the perspective plot function \code{persp}.
        }
    \item{\dots}{
        [contour][persp] - \cr
        additional arguments to be passed to the perspectice and countour
        plot functions.
        }
    
}

 
\value{
    
    \code{gridData} - \cr
    A list with at least three entries, \code{x}, \code{y} and \code{z}. 
    
    The returned values, can be directly used by the \code{persp.gridData()} 
    and \code{contour.gridData} 3D plotting methods.
    
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port,\cr
    H. Akima for the Fortran Code of the Akima spline interpolation routine.\cr
    
}


\examples{
## gridData -
   # Grid Data Set
   gD = gridData()
   persp(gD)
   contour(gD)
}


\keyword{programming}

\name{utils-density2d}

\alias{density2d}
\alias{hist2d}


\title{Bivariate Density Tools}


\description{
    
    Kernel density estimator and histogram counter for 
    bivariate distributions

}


\usage{
density2d(x, y = NULL, n = 20, h = NULL, limits = c(range(x), range(y))) 

hist2d(x, y = NULL, n = c(20, 20))
}


\arguments{

    \item{x, y}{
        two vectors of coordinates of data. If \code{y} is NULL then
        \code{x} is assumed to be a two column matrix, where the first 
        column contains the \code{x} data, and the second column the 
        \code{y} data. 
        }
    \item{n}{
        n - an integer specifying the number of grid points in each 
        direction. The default value is 20.\cr
        [hist2D] - \cr
        In this case \code{n} may be a scalar or a two element vector. 
        The default value is 20.
        }
    \item{h}{
        a vector of bandwidths for \code{x} and \code{y} directions. 
        Defaults to normal reference bandwidth. 
        }
    \item{limits}{
        the limits of the rectangle covered by the grid.   
        }
        
}


\value{

    \code{density2d} and \code{hist2d}
    return a list with three elements \code{$x}, \code{$y}, and 
    \code{$z}. \code{x} and \code{y} are vectors spanning the two 
    dimensional grid and \code{z} the corresponding matrix. The 
    output can directly serve as input to the plotting functions 
    \code{image}, \code{contour} and \code{persp}.
    
}


\references{
    
Azzalini A., (2004);
    \emph{The sn Package};
    R Reference Guide available from www.r-project.org.
    
Venables W.N., Ripley B.D., (2002); 
    \emph{Modern Applied Statistics with S},
    Fourth Edition, Springer.
    
Warnes G.R., (2004);
    \emph{The gregmisc Package};
    R Reference Guide available from www.r-project.org.
         
}


\author{

    W.N. Venables and B.D. Ripley for the underlying kde2d function, \cr
    Gregory R. Warnes for the underlying hist2d function, \cr
    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## hist2d - 
   # Normal Random Numbers:
   set.seed(4711)
   X <- rnorm2d(40000)
   # 2D Histogram Plot:
   Z <- hist2d(X)
   image(Z)
   contour(Z, add=TRUE)
}

\keyword{math}

\name{elliptical2d}


\alias{elliptical2d}
\alias{delliptical2d}


\title{Bivariate Elliptical Densities}


\description{
    
    Density function for bivariate elliptical 
    distributions. 
}


\usage{
delliptical2d(x, y = x, rho = 0, param = NULL, type = c("norm", "cauchy", "t", 
    "logistic", "laplace", "kotz", "epower"), output = c("vector", "list"))
}


\arguments{

    \item{output}{
        output - a character string specifying how the output should be 
        formatted. By default a vector of the same length as \code{u} 
        and \code{v}. If specified as \code{"list"} then \code{u} and 
        \code{v} are expected to span a two-dimensional grid as outputted 
        by the function \code{grid2d} and the function returns a list with
        elements \code{$x}, \code{y}, and \code{z} which can be directly 
        used for example by 2D plotting functions.
        }
    \item{param}{
        additional parameters to specify the bivariate density function.
        Only effective for the Kotz and Exponential Power distribution.
        For the Kotz distribution we can specify a numeric value, by default
        defined as \code{param=c(r=sqrt(2))}, and for the Exponential
        Power distribution a numeric vector, by default defined as
        \code{param=c(r=sqrt(2)),s=1/2}.
        }
    \item{rho}{
        the correlation parameter, a numeric value ranging between 
        minus one and one, by default zero.     
        }
    \item{type}{
        the type of the elliptical copula. A character string selected 
        from: \code{"norm"}, \code{"cauchy"}, \code{"t"}, \code{"laplace"}, 
        \code{"kotz"}, or \code{"epower"}.
        }
    \item{x, y}{
        two numeric vectors defining the x and y coordinates. \cr
        }
        
}


\value{
 
    \code{delliptical2d}
    \cr
    returns a two column matrix of densities for the selected bivariate 
    elliptical distribution function.
    
}


\references{
    
Azzalini A., (2004);
    \emph{The sn Package};
    R Reference Guide available from www.r-project.org.
    
Venables W.N., Ripley B.D., (2002); 
    \emph{Modern Applied Statistics with S},
    Fourth Edition, Springer.
         
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## Kotz' Elliptical Density:
   x = (-40:40)/10
   X = grid2d(x)
   z = delliptical2d(X$x, X$y, rho = 0.5, type = "kotz")
   Z = list(x = x, y = x, z = matrix(z, ncol = length(x)))
   persp(Z, theta = -40, phi = 30, col = "steelblue")
}


\keyword{math}

\name{zzz-mvnorm}


\title{Multivariate Normal Distribution}


\description{
    
    Alternative density, distribution function, and random generation 
    for the multivariate Normal distribution. 
    
}


\details{
    
    The multivariate distribution functions to compute densities 
    \code{dmvnorm}, probabilities \code{pmvnorm}, and to generate 
    random numbers \code{rmvnorm} are available from the contributed 
    R package \code{mvtnorm}.
    The function \code{qmvnorm} computes the equicoordinate quantile 
    function of the multivariate normal distribution for arbitrary 
    correlation matrices based on inversion of \code{pmvnorm}.
    
    \code{dmvnorm(x, mean, sigma, <<...>>}\cr
    \code{pmvnorm(<<...>>)}\cr
    \code{qmvnorm(p, <<...>>)}\cr
    \code{rmvnorm(n, mean, sigma, <<...>>}
    
    NOTE: The function are not builtin in the package \code{fMultivar}.
    Fur details we refer to the help page of \code{mvnorm}.
         
}


\author{

    Friedrich Leisch and Fabian Scheipl.

}


\examples{
\dontrun{
## Load Libray:
   require(mvtnorm)
   
## dmvnorm - 
   # Multivariate Normal Density Function:
   mean <- c(1, 1)
   sigma <- matrix(c(1, 0.5, 0.5, 1), ncol=2) 
   dmvnorm(x = c(0, 0),mean, sigma)
   
## dmvnorm - 
   # Across a Grid:
   x <- seq(-4, 4, length=90)
   X <- grid2d(x)
   X <- cbind(X$x, X$y) 
   # Write Density Function:
   dmvnorm. <- function(X, mean, sigma)
     matrix(apply(X, 1, dmvnorm, mean=mean, sigma=sigma), ncol=sqrt(dim(X)[1]))
   z <- dmvnorm.(X, mean, sigma)
   contour(list(x = x, y = x, z = z))
   
## qmvnorm -
   # Equicoordinate Quantile Function:
   qmvnorm(p = 0.95, sigma = diag(2), tail = "both")
   
## rmvnorm - 
   # Random Numbers:
   sigma <- matrix(c(4, 2, 2, 3), ncol=2)
   x <- rmvnorm(n = 500, mean = c(1, 2), sigma = sigma)
   colMeans(x)
   var(x)
   # Next Generation:
   x <- rmvnorm(n = 500, mean = c(1, 2), sigma = sigma, method = "chol")
   colMeans(x)
   var(x)
   plot(x, cex=0.5, pch=19, col="steelblue")
}
}


\keyword{math}

\name{mvdist-mscFit}


\alias{mscFit}


\title{Multivariate Skew Cauchy Parameter Estimation}


\description{
    
    Fitting the parameters for the Multivariate Skew Cauchy
    Distribution.
    
}


\usage{
    mscFit(x, trace=FALSE, title = NULL, description = NULL)
}


\arguments{

    \item{x}{
        a matrix with "d" columns, giving the coordinates of the 
        point(s) where the density must be evaluated.
        }
    \item{trace}{
        a logical value, should the estimation be traced? By default
        FALSE.
        }
    \item{title}{
        an optional project title.
        }
    \item{description}{
        an option project desctiption. 
        }

}


\details{

    This is an easy to use wrapper function using default function 
    settings for fitting the distributional parameters in the framework 
    of the contributed package \code{"sn"} written by Adelchi Azzalini. 
    
    Starting values for the estimation have not to be provided, they
    are automatically created.
    
}


\examples{
\dontrun{
## Load Library:
   require(sn)
   
## mscFit - 
   # Fit Example:
   N <- 1000
   xi <- c(0, 0) 
   Omega <- diag(2); Omega[2,1] <- Omega[1,2] <- 0.5
   alpha <- c(2, -6)
   set.seed(4711)
   X <- rmsc(n=N, xi, Omega, alpha)
   ans <- mscFit(X)
   # Show fitted Parameters:
   print(ans)
   
   # 2-D Density Plot:
   plot(hexBinning(X[,1], X[, 2], bins = 30), main="Skew Cauchy")
   # Add Contours:
   N <- 101
   x <- seq(min(X[, 1]), max(X[, 1]), l=N)
   y <- seq(min(X[, 2]), max(X[, 2]), l=N)        
   u <- grid2d(x, y)$x
   v <- grid2d(x, y)$y
   XY <- cbind(u, v)
   param <- ans@fit$dp
   Z <- matrix(dmsc(XY, param[[1]][1,], param[[2]], param[[3]]), ncol=N)
   contour(x, y, Z, add=TRUE, col="green", lwd=2)
   grid(col="brown", lty=3)
   
## Cut the Tails:
   CUT <- 25
   X <- X[abs(X[, 1]) <= CUT, ] 
   X <- X[abs(X[, 2]) <= CUT, ]   
   plot(hexBinning(X[,1], X[, 2], bins = 30), main="Skew Cauchy")
   x <- y <- seq(-CUT, CUT, l=N) 
   u <- grid2d(x, y)$x
   v <- grid2d(x, y)$y
   XY <- cbind(u, v)
   param <- ans@fit$dp
   Z <- matrix(dmsc(XY, param[[1]][1,], param[[2]], param[[3]]), ncol=N)
   contour(x, y, Z, add=TRUE, col="green", lwd=2)
   grid(col="brown", lty=3)
   # Try larger cuts ...
}
}


\keyword{math}

\name{MultivariateDistribution}

\alias{MultivariateDistribution}

\alias{show,fMV-method}

\alias{fMV}
\alias{fMV-class}

\alias{dmvsnorm}
\alias{pmvsnorm}
\alias{rmvsnorm}

\alias{dmvst}
\alias{pmvst}
\alias{rmvst}

\alias{mvFit}

\alias{print.fMV}
\alias{plot.fMV}
\alias{summary.fMV}


\title{Multivariate Skew Normal and Student-t Distributions}


\description{
  
    A collection and description of functions to compute 
    multivariate densities and probabilities from skew 
    normal and skew Student-t distribution functions. 
    Furthermore, multivariate random daviates can be 
    generated, and for multivariate data, the parameters 
    of the underlying distribution can be estimated 
    by the maximum log-likelihood estimation.
    \cr
    
    The functions are:
    
    \tabular{ll}{
    \code{dmvsnorm} \tab Multivariate Skew Normal Density, \cr
    \code{pmvsnorm} \tab Multivariate Skew Normal Probability, \cr
    \code{rmvsnorm} \tab Random Deviates from MV Skew Normal Distribution, \cr
    \code{dmvst} \tab Multivariate Skew Student Density, \cr
    \code{pmvst} \tab Multivariate Skew Student Probability, \cr
    \code{rmvst} \tab Random Deviates from MV Skew Student Distribution, \cr
    \code{mvFit} \tab Fits a MV Skew Normal or Student-t Distribution, \cr
    \code{print} \tab S3 print method for an object of class 'fMV', \cr
    \code{plot} \tab S3 Plot method for an object of class 'fMV', \cr
    \code{summary} \tab S3 summary method for an object of class 'fMV'. }
    
    These functions are useful for portfolio selection and optimization
    if one likes to model the data by multivariate normal, skew normal,
    or skew Student-t distribution functions.
    
}
    

\usage{
dmvsnorm(x, dim = 2, mu = rep(0, dim), Omega = diag(dim), alpha = rep(0, dim))
pmvsnorm(q, dim = 2, mu = rep(0, dim), Omega = diag(dim), alpha = rep(0, dim))
rmvsnorm(n, dim = 2, mu = rep(0, dim), Omega = diag(dim), alpha = rep(0, dim))

dmvst(x, dim = 2, mu = rep(0, dim), Omega = diag(dim), alpha = rep(0, dim), df = 4)
pmvst(q, dim = 2, mu = rep(0, dim), Omega = diag(dim), alpha = rep(0, dim), df = 4)
rmvst(n, dim = 2, mu = rep(0, dim), Omega = diag(dim), alpha = rep(0, dim), df = 4)


mvFit(x, method = c("snorm", "st"), fixed.df = NA, title = NULL, 
    description = NULL, trace = FALSE, \dots) 

\S4method{show}{fMV}(object)    
    
\method{plot}{fMV}(x, which = "ask", \dots)
\method{summary}{fMV}(object, which = "ask", doplot = TRUE, \dots)
}


\arguments{
  
    \item{description}{
        [mvFit] - \cr
        a character string, assigning a brief description to an 
        \code{"fMV"} object.
        }
    \item{doplot}{
        a logical value, by default TRUE. Should a plot be generated
        and displayed?
        }
    \item{dim}{
        [*mvsnorm][*mvst] - \cr
        the colum dimension of the matrix \code{x}. If \code{x} is 
        specified as a vector, \code{dim=1} must be set to one.
        }
    \item{fixed.df}{
        either \code{NA}, the default, or a numeric value assigning the
        number of degrees of freedom to the model. In the case that 
        \code{fixed.df=NA} the value of \code{df} will be included in the
        optimization process, otherwise not.
        }
    \item{method}{
        [mvFit] - \cr
        a string value specifying the method applied in the optimizing 
        process. This can be either \code{method="snorm"} or 
        \code{method="st"}, in the first case the parameters for a
        skew normal distribution will be fitted and in the second case
        the parameters for a skew Student-t distribution. 
        }
    \item{mu, Omega, alpha, df}{
        [*mvsnorm][*mvst] - \cr
        the model parameters: \cr
        \code{mu} a vector of mean values, one for each column, \cr
        \code{Omega} the covariance matrix, \cr
        \code{alpha} the skewness vector, and \cr
        \code{df} the number of degrees of freedom which is a measure for
            the fatness of the tails (excess kurtosis). \cr
        For a symmetric distribution \code{alpha} is a vector of zeros.
        For the normal distributions \code{df} is not used and set to 
        infinity, \code{Inf}. Note that all columns assume the same value 
        for \code{df}.
        }   
    \item{n}{
        [rmvsnorm][rmvst] - \cr
        number of data records to be simulated, an integer value.
        }
    \item{object}{
        [summary] - \cr
        an object of class \code{fMV}.
        }  
    \item{title}{
        [mvFit] - \cr
        a character string, assigning a title to an \code{"fMV"} object.
        }
    \item{trace}{
        a logical, if set to \code{TRUE} the optimization process will
        be traced, otherwise not. The default setting is \code{FALSE}.
        }
    \item{which}{
        which of the five plots should be displayed? \code{which} can 
        be either a character string, \code{"all"} (displays all plots) 
        or \code{"ask"} (interactively asks which one to display), or a 
        vector of 5 logical values, for those elements which are set 
        \code{TRUE} the correponding plot will be displayed.
        }
    \item{x, q}{
        [*mvsnorm][*mvst][mvFit] - \cr
        a numeric matrix of quantiles (returns) or any other rectangular 
        object like a data.frame or a multivariate time series objects 
        which can be transformed by the function \code{as.matrix} to an 
        object of class \code{matrix}. If \code{x} is a vector, it will 
        be transformed into a matrix object with one column.
        \cr
        [plot][print] - \cr
        An object of class \code{fMV}.
        }  
    \item{\dots}{
        optional arguments to be passed to the optimization or plotting
        functions.
        }
        
}


\details{

    These are "easy-to-use" functions which allow quickly to simulate 
    multivariate data sets and to fit their parameters assuming a 
    multivariate skew normal or skew Student-t distribution. The functions
    make use of the contributed R packages \code{sn} and \code{mtvnorm}.
    
    For an extended functionality in modelling multivariate skew normal
    and Student-t distributions we recommend to download and use the 
    functions from the original package \code{sn} which requires also the
    package \code{mtvnorm}.
    
    The algorithm for the computation of the normal and Student-t 
    distribution functions is described by Genz (1992) and (1993), 
    and its implementation by Hothorn, Bretz, and Genz (2001).
    
    The parameter estimation is done by the maximum log-likelihood
    estimation. The algorithm and the implemantation was done by
    Azzalini (1985-2003). 
    
    The multivariate skew-normal distribution is discussed in detail
    by Azzalini and Dalla Valle (1996); the \code{(Omega,alpha)} 
    parametrization adopted here is the one of Azzalini and 
    Capitanio (1999). 
    
    The family of multivariate skew-t distributions is an extension of 
    the multivariate Student's t family, via the introduction of a 
    shape parameter which regulates skewness; for a zero shape parameter
    the skew Student-t distribution reduces to the usual t distribution. 
    When \code{df = Inf} the distribution reduces to the multivariate 
    skew-normal one.
    
    The plot facilities have been completely reimplemented. The S3 plot
    method allows for selective batch and interactive plots. The 
    argument \code{which} takes care for the desired operation.
    
    The contributed R package \code{mvtnorm} is required, the contributed 
    R package \code{sn} is builtin, since it is not available on the
    Debian Software Server.   
}


\value{

    \code{[dp]mvsnorm} \cr
    \code{[dp]mvst}
    \cr
    return a vector of density and probability values computed from
    the matrix \code{x}.
    \cr
  
    \code{mvFit} 
    \cr
    returns a S4 object class of class \code{"fASSETS"}, with the following 
    slots:

    \item{@call}{
        the matched function call.
        }
    \item{@data}{
        the input data in form of a data.frame.
        }
    \item{@description}{
        allows for a brief project description.
        }
    \item{@fit}{
        the results as a list returned from the underlying
        fitting function. 
        }
    \item{@method}{
        the selected method to fit the distribution, either 
        \code{"snorm"}, or \code{"st"}.
        }
    \item{@model}{
        the model parameters describing the fitted parameters in 
        form of a list, \code{model=list(mu, Omega, alpha, df}.
        }
    \item{@title}{
        a title string.}
        
    The \code{@fit} slot is a list with the following compontents:
    (Note, not all are documented here).
    
    \item{@fit$dp}{
        a list containing the direct parameters beta, Omega, alpha. 
        Here, beta is a matrix of regression coefficients with 
        \code{dim(beta)=c(nrow(X), ncol(y))}, \code{Omega} is a 
        covariance matrix of order \code{dim}, \code{alpha} is 
        a vector of shape parameters of length \code{dim}.  
        }
    \item{@fit$se}{
        a list containing the components beta, alpha, info. Here, 
        beta and alpha are the standard errors for the corresponding 
        point estimates; info is the observed information matrix 
        for the working parameter, as explained below.
        }  
    \item{@fit$optim}{ 
        the list returned by the optimizer \code{optim}; see the 
        documentation of this function for explanation of its 
        components.  
        }

    \code{print} 
    \cr
    is the S3 print method for objects of class \code{"fMV"} returned
    from the function \code{mvFit}. If shows a summary report of
    the parameter fit.
    
    \code{plot} 
    \cr
    is the S3 plot method for objects of class \code{"fMV"} returned
    from the function \code{mvFit}. Five plots are produced. 
    The first plot produces a scatterplot and in one dimension an 
    histogram plot with the fitted distribution superimposed. 
    The second and third plot represent a QQ-plots of Mahalanobis 
    distances. The first of these refers to the fitting 
    of a multivariate normal distribution, a standard statistical 
    procedure; the second gives the corresponding QQ-plot of 
    suitable Mahalanobis distances for the multivariate skew-normal 
    fit. The fourth and fivth plots are similar to the previous ones, 
    except that PP-plots are produced. The plots can be displayed
    in several ways, depending an the argument \code{which}, for 
    details we refer to the arguments list above.

    \code{summary}
    \cr
    is the S3 summary method for objects of class \code{"fMV"} returned
    from the function \code{mvFit}. The summary method prints and plots
    in one step the results as done by the \code{print} and \code{plot} 
    methods.
  
}


\references{

Azzalini A. (1985);
    \emph{A Class of Distributions Which Includes the Normal Ones},
    Scandinavian Journal of Statistics 12, 171--178. 

Azzalini A. (1986);
    \emph{Further Results on a Class of Distributions Which Includes 
        the Normal Ones},
    Statistica 46, 199--208. 

Azzalini A., Dalla Valle A. (1996);
    \emph{The Multivariate Skew-normal Distribution},
    Biometrika 83, 715--726. 

Azzalini A., Capitanio A. (1999);
    \emph{Statistical Applications of the Multivariate Skew-normal 
        Distribution},
    Journal Roy. Statist. Soc. B61, 579--602. 

Azzalini A., Capitanio A. (2003);
    \emph{Distributions Generated by Perturbation of Symmetry with 
        Emphasis on a Multivariate Skew-t Distribution},
    Journal Roy. Statist. Soc. B65, 367--389. 
    
Genz A., Bretz F. (1999);
    \emph{Numerical Computation of Multivariate t-Probabilities
        with Application to Power Calculation of Multiple Contrasts}, 
    Journal of Statistical Computation and Simulation 63, 361--378.

Genz A. (1992);
    \emph{Numerical Computation of Multivariate Normal Probabilities},
    Journal of Computational and Graphical Statistics 1, 141--149.
    
Genz A. (1993); 
    \emph{Comparison of Methods for the Computation of Multivariate
        Normal Probabilities},
    Computing Science and Statistics 25, 400--405.
    
Hothorn T., Bretz F., Genz A. (2001);
    \emph{On Multivariate t and Gauss Probabilities in R},
    R News 1/2, 27--29.
    
}


\author{

    Torsten Hothorn for R's \code{mvtnorm} package, \cr
    Alan Ganz and Frank Bretz for the underlying Fortran Code, \cr
    Adelchi Azzalini for R's \code{sn} package, \cr
    Diethelm Wuertz for the Rmetrics port.
    
}


\examples{
## rmvst - 
   par(mfcol = c(3, 1), cex = 0.7)
   r1 = rmvst(200, dim = 1)
   ts.plot(as.ts(r1), xlab = "r", main = "Student-t 1d")
   r2 = rmvst(200, dim = 2, Omega = matrix(c(1, 0.5, 0.5, 1), 2))
   ts.plot(as.ts(r2), xlab = "r", col = 2:3, main = "Student-t 2d")
   r3 = rmvst(200, dim = 3, mu = c(-1, 0, 1), alpha = c(1, -1, 1), df = 5)
   ts.plot(as.ts(r3), xlab = "r", col = 2:4, main = "Skew Student-t 3d")    
   
## mvFit - 
   # Generate Grid Points:
   n = 51
   x = seq(-3, 3, length = n)
   xoy = cbind(rep(x, n), as.vector(matrix(x, n, n, byrow = TRUE)))
   X = matrix(xoy, n * n, 2, byrow = FALSE)
   head(X)
   # The Bivariate Normal Case:
   Z = matrix(dmvsnorm(X, dim = 2), length(x))
   par (mfrow = c(2, 2), cex = 0.7)
   persp(x, x, Z, theta = -40, phi = 30, col = "steelblue") 
   title(main = "Bivariate Normal Plot")
   image(x, x, Z)
   title(main = "Bivariate Normal Contours")
   contour(x, x, Z, add = TRUE)
   # The Bivariate Skew-Student-t Case:
   mu = c(-0.1, 0.1)
   Omega = matrix(c(1, 0.5, 0.5, 1), 2)
   alpha = c(-1, 1)
   Z = matrix(dmvst(X, 2, mu, Omega, alpha, df = 3), length(x))
   persp(x, x, Z, theta = -40, phi = 30, col = "steelblue") 
   title(main = "Bivariate Student-t Plot")
   image(x, x, Z)
   contour(x, x, Z, add = TRUE)
   title(main = "Bivariate Student-t Contours")
}


\keyword{distribution}

\name{BivariateBinning}

\alias{BivariateBinning}

\alias{squareBinning}
\alias{hexBinning}
\alias{plot.squareBinning}
\alias{plot.hexBinning}

\title{Square and Hexagonal Data Binning}


\description{
    
    A collection and description of functions which
    allow to create histograms due to sqaure and
    hexagonal binning.
    \cr

    Bivariate Binning Functions:
    
    \tabular{ll}{
    \code{squareBinning} \tab does a square binning of data points, \cr
    \code{hexBinning} \tab does a hexagonal binning of data points}
    
}


\usage{ 
squareBinning(x, y = NULL, bins = 30)
hexBinning(x, y = NULL, bins = 30)

\method{plot}{squareBinning}(x, col = heat.colors(12), addPoints = TRUE, 
    addRug = TRUE, \dots)
\method{plot}{hexBinning}(x, col = heat.colors(12), addPoints = TRUE, 
    addRug = TRUE, \dots)
}

\arguments{
  
    \item{addPoints}{
        a logical flag, should the center of mass points added to the
        plot?
        }
    \item{addRug}{
        a logical flag, should a rug representation be added to the
        plot, for details see the function \code{rug}.
        }
    \item{bins}{
        an integer specifying the number of bins.
        } 
    \item{col}{
        color map like for the \code{image} function.
        }
    \item{x, y}{
        [squareBinning][hexBinning] - \cr
        either two numeric vectors of equal length or if  \code{y} 
        is NULL, a list with entries \code{x}, \code{y}, 
        or named data frame with \code{x} in the first and
        \code{y} in the second column.
        Note, \code{timeSeries} objects are also allowed as input.\cr
        [plot] - \cr
        an object of class \code{squareBinning} or \code{hexBinning}.
        }
    \item{\dots}{
        arguments to be passed.
        }
}


\value{
    
    A list with three entries, \code{x}, \code{y} and \code{z},
    specified by an oject of class \code{squareBinning} or 
    \code{hexBinning}.
    
    Note, the returned value, can be directly used by the \code{persp()} 
    and \code{contour} 3D plotting functions.
    
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## squareBinning -
   sB = squareBinning(x = rnorm(1000), y = rnorm(1000))
   plot(sB)
   
## hexBinning -
   hB = hexBinning(x = rnorm(1000), y = rnorm(1000))
   plot(hB)
}


\keyword{programming}

\name{fMultivar-package}

\alias{fMultivar-package}
\alias{fMultivar}


\docType{package}


\title{Modelling Multivariate Return Distributions}


\description{

  The Rmetrics "fMultivar"" package is a  collection of functions 
  to manage, to investigate and to analyze bivariate and multivariate 
  data sets of financial returns.
  
}


\details{

    \tabular{ll}{
        Package:    \tab fMultivar\cr
        Type:       \tab Package\cr
        Version:    \tab R 3.0.1\cr
        Date:       \tab 2014\cr
        License:    \tab GPL Version 2 or later\cr
        Copyright:  \tab (c) 1999-2014 Rmetrics Assiciation\cr
        URL:        \tab \url{https://www.rmetrics.org}
  }

}


\section{1 Introduction}{

  The package \code{fMultivar} was written to explore and investigate
  bivariate and multivariate financial return series. 
  The bivariate modeling allows us the comparison of financial returns
  from two investments or from one investment and its benchmark. When 
  it comes to the investigation of multiple investment returns from 
  funds or portfolios we are concerned with the multivariate case.
  
  In the case of bivariate distribution functions we provide functions
  for the 2-dimensional Cauchy, Normal, and Student-t distributions.
  A generalisation (for the density only) is made for the family of 
  2-dimensional elliptical distributions. In this case we provide density
  functions for the Normal, Cauchy, Student-t, Logistic, Laplace, Kotz, 
  e-Power distributions.
  
  In the case of multivariate distribution functions from the skew-normal 
  (SN) family and some related ones we recommend to 
  use the density funtions, probability functions and random number
  generators provided by Azzalini's contributed package \code{sn}.
  The family of his SN-distributions cover the skew Cauchy, the skew
  Normal, and the skew Student-t distributions. For parameter fitting
  we have added three simple wrapper functions for an easy to use
  approach to estimate the distributional parameters for financial
  return series.
  
  In the case of multivariate distribution functions from the generalized
  hyperbolic (GHYP) family and some related ones we recommend to 
  use the density funtions, probability functions and random number
  generators provided by David Luethi and Wolfgang Breymann's contributed 
  package \code{ghyp}.
  The family of their GHYP-distributions cover beside the General
  Hyperbolic distribution (GHYP) also the special cases for the
  Hyperbolic distribution (HYP), for the Normal Inverse Gaussian 
  distribution (NIG), for the Variance Gamma distribution (VG), and 
  for the skewed Student-t distribution (GHST).
}


\section{2 Bivariate Distributions}{

  This section contains functions to model bivariate density, 
  probability, quantile functions, and to generate random numbers
  for three standard distributions.
  
  \preformatted{
  [dpr]cauchy2d         Bivariate Cauchy Distribution
  [dpr]norm2d           Bivariate Normal Disribution
  [dpr]t2d              Bivariate Student-t Disribution
  }
  
  
  The density function 
  
  
  \preformatted{
  delliptical2d         Bivariate Elliptical Densities
  }
  
  
  computes for several bivariate elliptical distributions their
  densities. Included distributions are the following types:
  \code{"norm"}, \code{"cauchy"}, \code{"t"}, \code{"logistic"}, 
  \code{"laplace"}, \code{"kotz"}, and \code{"epower"}.
  
}


\section{3 Multivariate Symmetric Distributions}{

  \preformatted{
  [dpr]              Multivariate Cauchy Distribution
  [dpr]              Multivariate Normal Distribution
  [dpr]              Multivariate Student-t Distribution
  
  [dpr]              Multivariate Truncated Normal Distribution
  }
  
}


\section{3 Multivariate Skew Distributions}{

  We use the functions from the contributed package \code{"sn"} package 
  to model multivariate density and probability functions, and to 
  generate random numbers for the skew Cauchy, Normal and Student-t
  distributions. Note the symmetric case is also included in these
  functions. The functions are:
  
  \preformatted{
  [dpr]msc              Multivariate Skew Cauchy Distribution
  [dpr]msn              Multivariate Skew Normal Distribution
  [dpr]mst              Multivariate Skew Student-t Distribution
  }
    
  Note the functions are not part of the \code{fMultivar} package they
  depend on the \code{"sn"} package and are loaded when \code{fMultivar} 
  is loaded.
  
  NOTE: In the new version of the \code{fMultivar} package the following 
  two distribution functions \code{*mvsnorm} (multivariate Normal 
  distribution) and \code{*mvst} (multivariate Student-t Distribution)
  will become obsolete together with the \code{mvFit} parameter
  estimation function. The functionality is fully covered by the 
  \code{"sn"} package. (They will be most likely deprecated in the 
  future.)
  
  For parameter estimation please use the simple wrapper functions:
  
  \preformatted{
  mscFit                Multivariate Skew Cauchy Fit
  msnFit                Multivariate Skew Normal Fit
  mstFit                Multivariate Skew Student-t Fit
  }
  
  Thes parameter estimation functions will be in the same style
  as all the other fitting functions in other Rmetrics packages.
  
}


\section{4 Multivariate GHYP Distributions}{

  We refer to the package \code{"ghyp"} authored by
  David Luethi and  Wolfgang Breymann,

}


\section{5 Utility Functions}{

  We have also added some very useful utility functions for the
  bivariate case, these include 2-D grid generation, squared and
  hexagonal binned histograms, 2-D kernel density estimates, 
  bivariate histogram plots:
  
  \preformatted{
  grid2d                Bivariate Square Grid of Coordinates
  binning2d             Bivariate Square/Hexagonal Binning Plot
  density2d             Bivariate Kernel Density Plot
  hist2d                Bivariate Histogram Plot
  gridData              Bivariate gridded data set
  }
   
  For integration we have added two quadratur routines a simple one
  for the bivariate case and an adaptive one for the multivariate case:
  
  \preformatted{
  integrate2d           Bivariate Integration
  adapt                 Multivariate adaptive Quadratur
  }
  
  The function \code{adapt} is a wrapper to the function 
  \code{adaptIntegrate} from the new contributed package
  \code{cubature} authored by Stephan G. Johnson.
  
}


\section{About Rmetrics:}{

    The \code{fMultivar} Rmetrics package is written for educational 
    support in teaching "Computational Finance and Financial Engineering" 
    and licensed under the GPL.
    
}


\keyword{package}

\name{density2d}

\alias{density2d}

\alias{grid2d}
\alias{density2d}
\alias{hist2d}
\alias{integrate2d}


\title{Bivariate Density Tools}


\description{
    
    Grid generator, kernel density estimator, 
    histogram counter, and integrator for 
    bivariate distributions

}


\usage{
grid2d(x = (0:10)/10, y = x)
density2d(x, y = NULL, n = 20, h = NULL, limits = c(range(x), range(y))) 
hist2d(x, y = NULL, n = c(20, 20))
integrate2d(fun, error = 1.0e-5, \dots)
}


\arguments{

    \item{error}{
        the error bound to be achieved by the integration formula.
        A numeric value.
        }
    \item{fun}{
        the function to be integrated. The first argument requests
        the x values, the second the y values, and the remaining
        are reserved for additional parameters. The integration is 
        over the unit square "[0,1]\^2".
        }
    \item{h}{
        a vector of bandwidths for \code{x} and \code{y} directions. 
        Defaults to normal reference bandwidth. 
        }
    \item{limits}{
        the limits of the rectangle covered by the grid.   
        }
     \item{n}{
        n - an integer specifying the number of grid points in each 
        direction. The default value is 20.\cr
        [hist2D] - \cr
        In this case \code{n} may be a scalar or a two element vector. 
        The default value is 20.\cr
        [rnorm2d] - \cr
        the number of random deviates to be generated, an integer value.
        }
    \item{x, y}{
        two numeric vectors defining the x and y coordinates. \cr
        [density2D][hist2D] - \cr
        two vectors of coordinates of data. If \code{y} is NULL then
        \code{x} is assumed to be a two column matrix, where the first 
        column contains the \code{x} data, and the second column the 
        \code{y} data. 
        }
    \item{\dots}{
        parameters passed to the function to be integrated.     
    }
        
}


\value{

    \code{grid2d} 
    \cr
    returns a list with two vectors named \code{$x} and \code{$y} spanning 
    the grid defined by the coordinate vectors \code{x} and \code{y}.
    
    \code{density2d}\cr
    \code{hist2d}
    \cr
    returns a list with three elements \code{$x}, \code{$y}, and 
    \code{$z}. \code{x} and \code{y} are vectors spanning the two 
    dimensional grid and \code{z} the corresponding matrix. The 
    output can directly serve as input to the plotting functions 
    \code{image}, \code{contour} and \code{persp}.
    
    \code{integrate2d}
    \cr
    returns a list with the \code{$value} of the integral over the
    unit square [0,1]\^2, an \code{$error} estimate and the number 
    of grid \code{$points} used by the integration function. 
    
}


\references{
    
Azzalini A., (2004);
    \emph{The sn Package};
    R Reference Guide available from www.r-project.org.
    
Venables W.N., Ripley B.D., (2002); 
    \emph{Modern Applied Statistics with S},
    Fourth Edition, Springer.
    
Warnes G.R., (2004);
    \emph{The gregmisc Package};
    R Reference Guide available from www.r-project.org.
         
}


\author{

    W.N. Venables and B.D. Ripley for the underlying kde2d function, \cr
    Gregory R. Warnes for the underlying hist2d function, \cr
    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\keyword{math}

\name{mvdist-msc}


\title{Multivariate Skew Cauchy Distribution}


\description{
    
    Density, distribution function, and random number generation 
    for the multivariate Cauchy distribution. 
    
}


\details{
    
    The functions to compute densities \code{dmsc}, probabilities 
    \code{pmsc}, and to generate random numbers \code{rmsc} for the
    multivariate skew Cauchy distribution are available in the contributed 
    R package \code{sn} (note, they are no longer builtin in fMultivar). 
    The reason is that the performance for these functions in package
    \code{sn} has superseeded those used before in the package fMultivar.
    
    The usage of the \code{sn} functions is:
    
    \code{dmsc(x, xi, Omega, alpha, dp = NULL, log = FALSE)}\cr 
    \code{pmsc(x, xi, Omega, alpha, dp = NULL, ...) }\cr
    \code{rmsc(n, xi, Omega, alpha, dp = NULL)}
    
    NOTE: The multivariate skew-normal distribution is discussed by 
    Azzalini and Dalla Valle (1996). The \code{(Omega,alpha)} 
    parametrization adopted here is the one of Azzalini and Capitanio 
    (1999). Chapter 5 of Azzalini and Capitanio (2014) provides an 
    extensive account, including subsequent developments.
    Be aware that the location vector \code{xi} does not represent 
    the mean vector of the distribution. Similarly,\code{Omega} is 
    not the covariance matrix of the distribution, although it is 
    a covariance matrix.

    For further details we refer to the help page in the package 
    \code{sn}.

}


\references{
  Azzalini, A. and Dalla Valle, A. (1996), 
  The multivariate skew-normal distribution,
  Biometrika 83, 715-726.

  Azzalini, A. and Capitanio, A. (1999), 
  Statistical applications of the multivariate skew normal distribution,
  Journal Roy.Statist.Soc. B 61, 579-602, 
  Full-length version available at http://arXiv.org/abs/0911.2093

  Azzalini, A. with the collaboration of Capitanio, A. (2014),
  The Skew-Normal and Related Families,
  Cambridge University Press, IMS Monographs Series.
}


\examples{
\dontrun{
## grid2d - 
   # Make 2-D Grid Coordinates:
   N <- 101
   x <- y <- seq(-3, 3, l=N)
   X <- cbind(u=grid2d(x)$x, v=grid2d(x)$y)
   
## Set Parameters:
   xi <- c(0, 0) 
   Omega <- diag(2); Omega[2,1] <- Omega[1,2] <- 0.5
   alpha <- c(2, -6)
   
## dmsc - 
   # Compute skew Cauchy Density:
   z <- sn::dmsc(X, xi, Omega, alpha)
   Z <- list(x=x, y=x, z=matrix(z, ncol = length(x)))
   # Plot:   
   image(Z, main ="Skew Cauchy Density")
   contour(Z, add=TRUE)
   grid(col="red")

## pmsc - 
   # Compute skew Cauchy Probability:
   z <- NULL
   for (i in 1:nrow(X)) z <- c(z, sn::pmsc(X[i, ], xi, Omega, alpha)[[1]])
   Z <- list(x=x, y=x, z=matrix(z, ncol = length(x)))
   # Plot:   
   image(Z, main ="Skew Cauchy Probability")
   contour(Z, add=TRUE)
   grid(col="red")
   
## rmsc - 
   # Skew Cauchy Random Deviates:
   set.seed(4711)
   r <- sn::rmsc(10000, xi, Omega, alpha)
   plot(hexBinning(r[, 1], r[, 2]))
   # Note, we have fat tails ...
}
}


\keyword{math}

\name{utils-integrate2d}


\alias{integrate2d}


\title{Bivariate Integration Tools}


\description{
    
    Integrates over the unit square.

}


\usage{
integrate2d(fun, error = 1.0e-5, \dots)
}


\arguments{

    \item{fun}{
        the function to be integrated. The first argument requests
        the x values, the second the y values, and the remaining
        are reserved for additional parameters. The integration is 
        over the unit square "[0,1]\^2".
    }
        \item{error}{
        the error bound to be achieved by the integration formula.
        A numeric value.
        }
    \item{\dots}{
        parameters passed to the function to be integrated.     
    }
        
}


\value{

    \code{integrate2d}
    returns a list with the \code{$value} of the integral over the
    unit square [0,1]\^2, an \code{$error} estimate and the number 
    of grid \code{$points} used by the integration function. 
    
}


\references{
    
Azzalini A., (2004);
    \emph{The sn Package};
    R Reference Guide available from www.r-project.org.
    
Venables W.N., Ripley B.D., (2002); 
    \emph{Modern Applied Statistics with S},
    Fourth Edition, Springer.
    
Warnes G.R., (2004);
    \emph{The gregmisc Package};
    R Reference Guide available from www.r-project.org.
         
}


\author{

    W.N. Venables and B.D. Ripley for the underlying kde2d function, \cr
    Gregory R. Warnes for the underlying hist2d function, \cr
    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\keyword{math}

\name{bvdist-t2d}


\alias{t2d}

\alias{dt2d}
\alias{pt2d}
\alias{rt2d}


\title{Bivariate Student-t Distribution}


\description{
    
    Density, distribution function, and random generation for 
    the bivariate Student-t distribution. 
    
}


\usage{
dt2d(x, y, rho = 0, nu = 4)
pt2d(x, y, rho = 0, nu = 4)
rt2d(n, rho = 0, nu = 4)
}


\arguments{

     \item{n}{
        the number of random deviates to be generated, an integer value.
        }
    \item{nu}{
        the number of degrees of freedom, a numeric value ranging between 
        two and infinity, by default four.      
        }
    \item{rho}{
        the correlation parameter, a numeric value ranging between 
        minus one and one, by default zero.     
        }
    \item{x, y}{
        two numeric vectors defining the x and y coordinates.
        }
        
}


\value{

    \code{pt2d}
    \cr
    returns a two column matrix of probabilities for the bivariate 
    Student-t distribution function.\cr
    
    \code{dt2d}
    \cr
    returns a two column matrix of densities for the bivariate 
    Student-t distribution function.\cr 
    
    \code{rt2d}
    \cr
    returns a two column matrix of random deviates generated from
    the bivariate Student-t distribution function.
    
}


\references{
    
Azzalini A., (2004);
    \emph{The sn Package};
    R Reference Guide available from www.r-project.org.
    
Venables W.N., Ripley B.D., (2002); 
    \emph{Modern Applied Statistics with S},
    Fourth Edition, Springer.
         
}


\author{

    Adelchi Azzalini for the underlying \code{pnorm2d} function, \cr
    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## dt2d -
   # Bivariate Student-t Density:
   x <- (-40:40)/10
   X <- grid2d(x)
   z <- dt2d(X$x, X$y, rho = 0.5, nu = 6)
   Z <- list(x = x, y = x, z = matrix(z, ncol = length(x)))
   # Perspective Plot:
   persp(Z, theta = -40, phi = 30, col = "steelblue")
   # Contour Plot:
   contour(Z)
   
## pt2d -
   # Bivariate Student-t Probability:
   x <- (-40:40)/10
   X <- grid2d(x)
   z <- pt2d(X$x, X$y, rho = 0.5, nu = 6)
   Z <- list(x = x, y = x, z = matrix(z, ncol = length(x)))
   # Image Plot with Contours:
   image(Z)
   contour(Z, add=TRUE)
}


\keyword{math}

\name{mvdist-msnFit}


\alias{msnFit}


\title{Multivariate Skew Normal Parameter Estimation}


\description{
    
    Fitting the parameters for the multivariate skew Normal
    distribution.
    
}


\usage{
    msnFit(x, trace = FALSE, title = NULL, description = NULL) 
}


\arguments{

     \item{x}{
        a matrix with "d" columns, giving the coordinates of the 
        point(s) where the density must be evaluated.
        }
    \item{trace}{
        a logical value, should the estimation be traced? By default
        FALSE.
        }
    \item{title}{
        an optional project title.
        }
    \item{description}{
        an option project desctiption. 
        }
    
}


\details{

    This is an easy to use wrapper function using default function 
    settings for fitting the distributional parameters in the framework 
    of the contributed package \code{"sn"} written by Adelchi Azzalini. 
    
    Starting values for the estimation have not to be provided, they
    are automatically created.
    
}


\examples{
\dontrun{
## Load Library:
   require(sn)
   
## msnFit - 
   # Fit Example:
   N <- 1000
   xi <- c(0, 0) 
   Omega <- diag(2); Omega[2,1] <- Omega[1,2] <- 0.5
   alpha <- c(2, -6)
   set.seed(4711)
   X <- rmsn(n=N, xi, Omega, alpha)
   ans <- msnFit(X)
   print(ans)

   # 2-D Density Plot:
   plot(hexBinning(X[,1], X[, 2], bins = 30), main="Skew Normal")
   # Add Contours:
   N <- 101
   x <- seq(min(X[, 1]), max(X[, 1]), l=N)
   y <- seq(min(X[, 2]), max(X[, 2]), l=N)        
   u <- grid2d(x, y)$x
   v <- grid2d(x, y)$y
   XY <- cbind(u, v)
   param <- ans@fit$estimate
   Z <- matrix(dmsn(XY, param[[1]][1,], param[[2]], param[[3]]), ncol=N)
   contour(x, y, Z, add=TRUE, col="green", lwd=2)
   grid(col="brown", lty=3)
}
}


\keyword{math}

\name{zzz-mvt}


\title{Multivariate Student-t Distribution}


\description{
    
    Alternative density, distribution function, and random generation 
    for the multivariate Student-t distribution. 
    
}


\details{
    
    The functions to compute densities \code{dmvt}, probabilities 
    \code{pmvt}, and to generate random numbers \code{rmvt} are 
    available from the contributed R package \code{mvtnorm}.
    The function \code{qmvt} computes the equicoordinate quantile 
    function of the multivariate normal distribution for arbitrary 
    correlation matrices based on inversion of \code{pmvt}.
    
    \code{dmvt(x, delta, sigma, df, <<...>>)}\cr
    \code{pmvt(<<...>>) }\cr
    \code{rmvt(n, sigma, df, delta, <<...>>}\cr
    
    NOTE: The function are not builtin in the package \code{fMultivar}.
    Fur details we refer to the help page of \code{mvnorm}.
         
}


\references{

  McNeil, A. J., Frey, R., and Embrechts, P. (2005), 
  \emph{Quantitative Risk Management: Concepts, Techniques, Tools},
  Princeton University Press.
  
}

\author{

  Alan Genz, Frank Bretz, Tetsuhisa Miwa, Xuefei Mi, Friedrich 
  Leisch, Fabian Scheipl, Bjoern Bornkamp, Torsten Hothorn.
    
}


\examples{
\dontrun{
## Load Libray:
   require(mvtnorm)
   
## dmvt - 
   # basic evaluation
   dmvt(x = c(0,0), sigma = diag(2))

## dmvt | dmvnorm - 
   # check behavior for df=0 and df=Inf
   x <- c(1.23, 4.56)
   mu <- 1:2
   Sigma <- diag(2)
   x0 <- dmvt(x, delta = mu, sigma = Sigma, df = 0) # default log = TRUE!
   x8 <- dmvt(x, delta = mu, sigma = Sigma, df = Inf) # default log = TRUE!
   xn <- dmvnorm(x, mean = mu, sigma = Sigma, log = TRUE)
   stopifnot(identical(x0, x8), identical(x0, xn))

## rmvt -
   # X ~ t_3(0, diag(2))
   x <- rmvt(100, sigma = diag(2), df = 3) # t_3(0, diag(2)) sample
   plot(x)

## rmvt -
   # X ~ t_3(mu, Sigma)
   n <- 1000
   mu <- 1:2
   Sigma <- matrix(c(4, 2, 2, 3), ncol=2)
   set.seed(271)
   x <- rep(mu, each=n) + rmvt(n, sigma=Sigma, df=3)
   plot(x)

## rmvt -
   # Note that the call rmvt(n, mean=mu, sigma=Sigma, df=3) does *not*
   # give a valid sample from t_3(mu, Sigma)! [and thus throws an error]
   try(rmvt(n, mean=mu, sigma=Sigma, df=3))

## rmvnorm - 
   # df=Inf correctly samples from a multivariate normal distribution
   set.seed(271)
   x <- rep(mu, each=n) + rmvt(n, sigma=Sigma, df=Inf)
   set.seed(271)
   x. <- rmvnorm(n, mean=mu, sigma=Sigma)
   stopifnot(identical(x, x.))
}
}


\keyword{math}

\name{utils-binning2}

\alias{utils-binning2}

\alias{squareBinning}
\alias{hexBinning}
\alias{plot.squareBinning}
\alias{plot.hexBinning}

\title{Square and Hexagonal Data Binning}


\description{
    
    Two functions which allow to create histograms due to sqaure 
    and hexagonal binning.
  
}


\usage{ 
squareBinning(x, y = NULL, bins = 30)
hexBinning(x, y = NULL, bins = 30)

\method{plot}{squareBinning}(x, col = heat.colors(12), addPoints = TRUE, 
    addRug = TRUE, \dots)
\method{plot}{hexBinning}(x, col = heat.colors(12), addPoints = TRUE, 
    addRug = TRUE, \dots)
}


\arguments{
  
    \item{addPoints}{
        a logical flag, should the center of mass points added to the
        plot?
        }
    \item{addRug}{
        a logical flag, should a rug representation be added to the
        plot, for details see the function \code{rug}.
        }
    \item{bins}{
        an integer specifying the number of bins.
        } 
    \item{col}{
        color map like for the \code{image} function.
        }
    \item{x, y}{
        [squareBinning][hexBinning] - \cr
        either two numeric vectors of equal length or if  \code{y} 
        is NULL, a list with entries \code{x}, \code{y}, 
        or named data frame with \code{x} in the first and
        \code{y} in the second column.
        Note, \code{timeSeries} objects are also allowed as input.\cr
        [plot] - \cr
        an object of class \code{squareBinning} or \code{hexBinning}.
        }
    \item{\dots}{
        arguments to be passed.
        }
}


\value{
    
    A list with three entries, \code{x}, \code{y} and \code{z},
    specified by an oject of class \code{squareBinning} or 
    \code{hexBinning}.
    
    Note, the returned value, can be directly used by the \code{persp()} 
    and \code{contour} 3D plotting functions.
    
}


\details{

    \code{squareBinning} does a square binning of data points, and
    \code{hexBinning} does a hexagonal binning of data points.
    
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## squareBinning -
   sB <- squareBinning(x = rnorm(1000), y = rnorm(1000))
   plot(sB)
   
## hexBinning -
   hB <- hexBinning(x = rnorm(1000), y = rnorm(1000))
   plot(hB)
}


\keyword{programming}

\name{bvdist-norm2d}

\alias{norm2d}

\alias{dnorm2d}
\alias{pnorm2d}
\alias{rnorm2d}


\title{Bivariate Normal Distribution}


\description{
    
    Density, distribution function, and random 
    generation for the bivariate normal
    distribution.
}


\usage{
dnorm2d(x, y, rho = 0)
pnorm2d(x, y, rho = 0)
rnorm2d(n, rho = 0)
}


\arguments{

     \item{x, y}{
        two numeric vectors defining the x and y coordinates. 
        }   
    \item{n}{
        the number of random deviates to be generated, an integer value.
        }
    \item{rho}{
        the correlation parameter, a numeric value ranging between 
        minus one and one, by default zero.     
        } 
        
}


\value{

    \code{pnorm2d}
    \cr
    returns a two column matrix of probabilities for the bivariate 
    normal distribution function.\cr
    
    \code{dnorm2d}
    \cr
    returns a two column matrix of densities for the bivariate 
    normal distribution function.\cr 
    
    \code{rnorm2d}
    \cr
    returns a two column matrix of random deviates generated from
    the bivariate normal distribution function.
    
}


\references{
    
Azzalini A., (2004);
    \emph{The sn Package};
    R Reference Guide available from www.r-project.org.
    
Venables W.N., Ripley B.D., (2002); 
    \emph{Modern Applied Statistics with S},
    Fourth Edition, Springer.
            
}


\author{

    Adelchi Azzalini for the underlying \code{pnorm2d} function, \cr
    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\examples{
## dnorm2d -
   # Bivariate Normal Density:
   x <- (-40:40)/10
   X <- grid2d(x)
   z <- dnorm2d(X$x, X$y, rho = 0.5)
   ZD <- list(x = x, y = x, z = matrix(z, ncol = length(x)))
   # Perspective Density Plot:
   persp(ZD, theta = -40, phi = 30, col = "steelblue")
   # Contour Density Plot:
   contour(ZD, main="Bivariate Normal Density")
    
## pnorm2d -
   # Bivariate Normal Probability:
   z <- pnorm2d(X$x, X$y, rho = 0.5)
   ZP <- list(x = x, y = x, z = matrix(z, ncol = length(x)))
   # Perspective Plot:
   persp(ZP, theta = -40, phi = 30, col = "steelblue")
   # Contour Plot:
   contour(ZP)
   
## rnorm2d - 
   # Bivariate Normal Random Deviates
   r <- rnorm2d(5000, rho=0.5)
   # Scatter Plot:
   plot(r, col="steelblue", pch=19, cex=0.5) 
   contour(ZD, add=TRUE, lwd=2, col="red")
   # Hexagonal Binning:
   plot(hexBinning(r))
   contour(ZD, add=TRUE, lwd=2, col="black")
}


\keyword{math}

\name{utils-grid2d}

\alias{grid2d}


\title{Bivariate Density Tools}


\description{
    
    Grid generator for bivariate distributions.

}


\usage{
grid2d(x = (0:10)/10, y = x)
}


\arguments{

    \item{x, y}{
        two numeric vectors defining the \code{x} and \code{y} coordinates.
        }
        
}


\value{

    \code{grid2d} 
    returns a list with two vectors named \code{$x} and \code{$y} spanning 
    the grid defined by the coordinate vectors \code{x} and \code{y}.
    
   
}


%\references{}


\author{

    Diethelm Wuertz.
    
}


\examples{
## grid2d -
   # Create a square grid:
   x <- seq(0, 10, length = 6)
   X <- grid2d(x = x, y = x)
   cbind(X$x, X$y)
}


\keyword{math}

\name{zzz-mvstnorm}


\alias{mvstnorm}

\alias{dmvsnorm}
\alias{pmvsnorm}
\alias{rmvsnorm}

\alias{dmvst}
\alias{pmvst}
\alias{rmvst}

\alias{mvFit}

\title{Obsolete Functions}


\description{
    
    Obsolete Functions: Alternative multivariate distribution and 
    parameter estimation functions for the skew normal and skew
    Student-t distribution functions. 
    
}


\details{

  The former implementations have been replaced by wrpper functions
  calling functions from the package \code{"sn"}.
}


\usage{
  dmvsnorm(x, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim))
  pmvsnorm(q, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim))
  rmvsnorm(n, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim))

  dmvst(x, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim), df=4)
  pmvst(q, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim), df=4)
  rmvst(n, dim=2, mu=rep(0, dim), Omega=diag(dim), alpha=rep(0, dim), df=4)   

  mvFit(x, method = c("snorm", "st"), fixed.df = NA, 
      title = NULL, description = NULL, trace = FALSE)
}


\arguments{

    \item{x, q}{
        the vector of quantiles, a matrix with "dim" columns.
        }
    \item{n}{
        the number of desired observations.
        }
    \item{dim}{
        the dimension, by default the bivariate case is considered
        where \code{dim=2}
        }
    \item{mu, Omega, alpha, df}{
        \code{mu} is a numeric vector of length "dim" representing 
        the location parameter of the distribution,
        \code{Omega} is a symmetric positive-definite matrix of dimension 
        "d" timesd "d",
        \code{alpha} is a numeric vector which regulates the 
        the slant of the density,
        \code{df} a positive value representing the degrees of freedom.
        }
    \item{method}{
        selects the type of distribution function, either \code{"snorm"}
        which is the default, or \code{"st"}. 
        }
    \item{fixed.df}{
        set to a positive value to keep fixed the parameter \code{nu}
        of the skew student-t distribution in the optimization process; 
        with default value NULL, i.e. \code{nu} is estimated like the 
        other parameters.
        }   
    \item{title}{
        an optional project title.
        }
    \item{description}{
        an option project desctiption. 
        }
    \item{trace}{
        a logical, should the estimation be traced?
        }
        
}


\value{

  \code{dm*} gives the density, \code{pm*} gives the distribution 
  function, and \code{rm*} generates \code{n} random deviates of
  dimension \code{dim}
  
  \code{mvFit} returns an object of class \code{fDISTFEED}, see
  package \code{fBasics}.

}


%\references{}



%\author{}


\examples{
\dontrun{
## Load Libray:
   require(mvtnorm)
   
## [dr]mvsnorm - 
   dmvsnorm(rnorm2d(100))
   rmvsnorm(100)

## [dr]mvst - 
   dmvst(rt2d(100))
   rmvst(100)
}
}


\keyword{math}

\name{utils-adapt}

\alias{adapt}


\title{Integrator for multivariate distributions}


\description{
    
    The function is for adaptive quadrature. 

}


\usage{
adapt(ndim, lower, upper, functn, \dots)
}


\note{

    In 2007 the package \code{adapt} was removed from the CRAN 
    repository, due to unclear license conditions. Nevertheless,
    formerly available versions can still be obtained from the CRAN 
    \href{https://cran.r-project.org/package=adapt}{archive}.
    Package \code{adapt} used FORTRAN code from Professor Genz.
    
    From 2007 until 2013 the package \code{fMultivar} used an builtin
    licensed by Professor Genz to Rmetrics. This version is still 
    available in the current package, have a look into the folder 
    \code{deprecated}.
    
    2013 the contributed package \code{cubature} was added to the CRAN
    repository. This provides an alternative n-dimensional integration 
    routine. We recommend to use the function \code{adaptIntegrate} 
    directly from the package \code{cubature} which allows adaptive 
    multivariate integration over hypercubes. It is a wrapper around 
    the pure C, GPLed implementation by Steven G. Johnson.
    
    Since 2014 \code{fMultivar} uses also the C Version based 
    implementation of Johnson. The former function \code{adapt}
    has been replaced by a wrapper function calling \code{adaptIntegrate}.
    The arguments \code{ndim}, \code{lower}, \code{upper}, and
    \code{functn} have been remeined the same, control parameters have
    been adapted to the function \code{cubature::adaptIntegrate}.
    
  
}


\arguments{

    \item{ndim}{   
        the dimension of the integral. By default NUll, no longer
        used.
        }
    \item{lower}{
        vector of at least length \code{ndim} of the lower bounds 
        on the integral.
        }
    \item{upper}{	
        vector of at least length \code{ndim} of the upper bounds 
        on the integral.
        }
    \item{functn}{	
        an R function which should take a single vector argument and 
        possibly some parameters and return the function value at 
        that point. \code{functn} must return a single numeric value.
        }
    \item{\dots}{	
        other parameters to be passed to the underlying function.
        }
        
}


\value{

  The returned value is a list of three items:

  \item{integral}{   
      the value of the integral.
      }
  \item{error}{ 
      the estimated relative error.
      }
  \item{functionEvaluations}{ 
      the number of times the function was evaluated.
      }
  \item{returnCode}{ 
      the actual integer return code of the C routine.
      }


}


\references{
    See: http://ab-initio.mit.edu/wiki/index.php/Cubature.
}


\author{
    Balasubramanian Narasimhan
}


\examples{
\donttest{
## Check that dnorm2d is normalized:
  
   # Normal Density:
   density <- function(x) dnorm2d(x=x[1], y = x[2])
      
   # Calling Cubature:
   BIG <- c(99, 99)
   cubature::adaptIntegrate(f=density, lowerLimit=-BIG, upperLimit=BIG)
   cubature::adaptIntegrate(f=density, low=-BIG, upp=BIG, tol=1e-7)
    
   # Using the Wrapper:
   adapt(lower=-BIG, upper=BIG, functn=density) 
   adapt(lower=-BIG, upper=BIG, functn=density, tol=1e-7)$integral
}
}


\keyword{math}
